Default = {
	name	="gHUD",
	version	="10009",
	author	="Mahiro/Grognaz - Aegwynn(EU)",
}

Options = {
	["update"]		= 0.01,
	["standby"] 	= 0,
	["lock"]		= 1,
	
	["showParty"]	= 1,
	["showTT"]		= 1,
	["showPet"]		= 1,
	["defMode"]		= 1,
	--["defModeHP"]		= 0,
	--["defModeMP"]		= 0,
	["defFormat"]	= 1,
	--["showDeficit"]		=1,
	
	["bgHeight"] 	= 250,
	["bgWidth"] 	= 10,
	["barWidth"] 	= 10,
	
	["playerPosX"] 	= 310,
	["playerPosY"] 	= -120,
	["targetPosX"] 	= 40,
	["targetPosY"] 	= 0,
	["partyPosX"] 	= 20,
	["partyPosY"] 	= 0,
	["petPosX"] 	= 20,
	["petPosY"] 	= 0,
	["ttPosX"] 		= 30,
	["ttPosY"] 		= 0,
	font = {
		["font"] 	= "Interface\\AddOns\\gHUD\\fonts\\comicbd.ttf",
		["size"] 	= 9,
		["flags"] 	= "",
	},
	texture = {
		["BarHeight"] 	= "Interface\\AddOns\\gHUD\\texture\\bar_h",
		["BGHeight"] 	= "Interface\\AddOns\\gHUD\\texture\\bg_h",
		["BarWidth"] 	= "Interface\\AddOns\\gHUD\\texture\\bar_w",
		["BGWidth"] 	= "Interface\\AddOns\\gHUD\\texture\\bg_w",
	},
}

Colors = {
	hp100 = {
		["r"]	=0,
		["g"]	=1,
		["b"]	=0,
		["a"]	=1,
	},
	hp50 = {
		["r"]	=1,
		["g"]	=1,
		["b"]	=0,
		["a"]	=1,
	},
	hp20 = {
		["r"]	=1,
		["g"]	=0,
		["b"]	=0,
		["a"]	=1,
	},
	mp100 = {
		["r"]	=0,
		["g"]	=0,
		["b"]	=1,
		["a"]	=1,
	},
	mp50 = {
		["r"]	=1,
		["g"]	=1,
		["b"]	=1,
		["a"]	=1,
	},
	mp20 = {
		["r"]	=1,
		["g"]	=0,
		["b"]	=0,
		["a"]	=1,
	},
}
---------------------------------------------------------
function gHUDOnLoad()

--Slash Commands	
	SLASH_gHUD_1 = "/groggy hud"
	SLASH_gHUD_2 = "/ghud"
	SlashCmdList["gHUD_"] = gHUD_Command
---------------------------------------------------------
--Handlers
	this:RegisterEvent("ADDON_LOADED")
	this:RegisterEvent("PLAYER_TARGET_CHANGED") 
	this:RegisterEvent("PARTY_MEMBERS_CHANGED")
	this:RegisterEvent("UNIT_PET")
	this.TimeSinceLastUpdate=0
end
--------------------------------------------------------
function TargetChangeOnEvent()
--show/hide target frames
	if (event=="PLAYER_TARGET_CHANGED") then
		if (UnitExists("target")) then
			HP_TARGET_FRAME:Show()
			if (UnitIsPlayer("target")==nil) 
			and (UnitPowerType("target")==1)  then
				UnregisterUnitWatch(MP_TARGET_FRAME)
				UnregisterUnitWatch(MP_Target_Button)
				MP_TARGET_FRAME:Hide()
			else
				RegisterUnitWatch(MP_TARGET_FRAME)
				RegisterUnitWatch(MP_Target_Button)
				MP_TARGET_FRAME:Show()
				MP_Target_Color()
			end
		end
	end
end

function PartyChangeOnEvent()
	---[[
	if (event=="PARTY_MEMBERS_CHANGED") then 
		if (Options.showParty==1) then
			if UnitInParty("party1") then
				HP_PARTY1_FRAME:Show()
				MP_PARTY1_FRAME:Show()
				MP_Party1_Color()
			else
				HP_PARTY1_FRAME:Hide()
				MP_PARTY1_FRAME:Hide()
			end
			if UnitInParty("party2") then
				HP_PARTY2_FRAME:Show()
				MP_PARTY2_FRAME:Show()
				MP_Party2_Color()
			else
				HP_PARTY2_FRAME:Hide()
				MP_PARTY2_FRAME:Hide()
			end
			if UnitInParty("party3") then
				HP_PARTY3_FRAME:Show()
				MP_PARTY3_FRAME:Show()
				MP_Party3_Color()
			else
				HP_PARTY3_FRAME:Hide()
				MP_PARTY3_FRAME:Hide()
			end
			if UnitInParty("party4") then
				HP_PARTY4_FRAME:Show()
				MP_PARTY4_FRAME:Show()
				MP_Party4_Color()
			else
				HP_PARTY4_FRAME:Hide()
				MP_PARTY4_FRAME:Hide()
			end
		else
			HP_PARTY1_FRAME:Hide()
			MP_PARTY1_FRAME:Hide()
			HP_PARTY2_FRAME:Hide()
			MP_PARTY2_FRAME:Hide()
			HP_PARTY3_FRAME:Hide()
			MP_PARTY3_FRAME:Hide()
			HP_PARTY4_FRAME:Hide()
			MP_PARTY4_FRAME:Hide()
		end
	end
	--]]
end

function PetChangeOnEvent()
--show/hide pet frames
	if (event=="UNIT_PET") then
		if (Options.showPet==1) then
			if (UnitExists("pet")) then
				HP_PET_FRAME:Show()
				MP_PET_FRAME:Show()
			else 
				HP_PET_FRAME:Hide()
				MP_PET_FRAME:Hide()
			end
		else 
			HP_PET_FRAME:Hide()
			MP_PET_FRAME:Hide()
		end
	end
end
---------------------------------------------------------
function Load_HP_Player()
	if (event=="ADDON_LOADED") and (arg1=="gHUD") then
	--set position
		HP_PLAYER_FRAME:ClearAllPoints()
		HP_PLAYER_FRAME:SetPoint("CENTER", nil, "CENTER", -Options.playerPosX, Options.playerPosY)
	--texture
		HP_PLAYER_BAR_TEXTURE:SetTexture(Options.texture.BarHeight)
		
		HP_PLAYER_BG_TEXTURE1:SetHeight(Options.bgHeight)
		HP_PLAYER_BG_TEXTURE1:SetWidth(Options.bgWidth)
		HP_PLAYER_BG_TEXTURE2:SetHeight(Options.bgHeight-2)
		HP_PLAYER_BG_TEXTURE2:SetWidth(Options.bgWidth-2)
		HP_PLAYER_BG_TEXTURE2:SetVertexColor(0,0,0,Colors.hp100.a)
		
		HP_PLAYER_BAR:SetWidth(Options.barWidth)
		HP_PLAYER_FRAME:SetHeight(Options.bgHeight)
		HP_PLAYER_FRAME:SetWidth(Options.bgWidth)
		
		HP_Player_Button:SetHeight(Options.bgHeight)
		HP_Player_Button:SetWidth(Options.bgWidth)
	--hp player max text
		HP_PLAYER_MAX:SetFont(Options.font.font, Options.font.size, Options.font.flags)
		HP_PLAYER_MAX:SetTextColor(0, 1, 0, 1)
	--hp player current text
		HP_PLAYER_CURRENT:SetFont(Options.font.font, Options.font.size, Options.font.flags)
	--hp player percent text
		HP_PLAYER_PERCENT:SetFont(Options.font.font, Options.font.size, Options.font.flags)
	--hp player deficit text
		HP_PLAYER_DEFICIT:SetFont(Options.font.font, Options.font.size, Options.font.flags)
	end
end
---------------------------------------------------------
function Load_MP_Player()
	if (event=="ADDON_LOADED") and (arg1=="gHUD") then
	--set position
		MP_PLAYER_FRAME:ClearAllPoints()
		MP_PLAYER_FRAME:SetPoint("CENTER", nil, "CENTER", Options.playerPosX, Options.playerPosY)
	--texture
		MP_PLAYER_BAR_TEXTURE:SetTexture(Options.texture.BarHeight)
		
		MP_PLAYER_BG_TEXTURE1:SetHeight(Options.bgHeight)
		MP_PLAYER_BG_TEXTURE1:SetWidth(Options.bgWidth)
		MP_PLAYER_BG_TEXTURE2:SetHeight(Options.bgHeight-2)
		MP_PLAYER_BG_TEXTURE2:SetWidth(Options.bgWidth-2)
		MP_PLAYER_BG_TEXTURE2:SetVertexColor(0,0,0,Colors.hp100.a)
		
		MP_PLAYER_BAR:SetWidth(Options.barWidth)
		MP_PLAYER_FRAME:SetHeight(Options.bgHeight)
		MP_PLAYER_FRAME:SetWidth(Options.bgWidth)
		
		MP_Player_Button:SetHeight(Options.bgHeight)
		MP_Player_Button:SetWidth(Options.bgWidth)
	--hp player max text
		MP_PLAYER_MAX:SetFont(Options.font.font, Options.font.size, Options.font.flags)
		if (UnitPowerType("player")==0) then
			MP_PLAYER_MAX:SetTextColor(0, 0, 1, 1)
		elseif (UnitPowerType("player")==1) then
			MP_PLAYER_MAX:SetTextColor(1, 0, 0, 1)
		elseif (UnitPowerType("player")==2) then
			MP_PLAYER_MAX:SetTextColor(1, 1, 0, 1)
		elseif (UnitPowerType("player")==3) then
			MP_PLAYER_MAX:SetTextColor(1, 1, 0, 1)
		end
	--hp player current text
		MP_PLAYER_CURRENT:SetFont(Options.font.font, Options.font.size, Options.font.flags)
	--hp player percent text
		MP_PLAYER_PERCENT:SetFont(Options.font.font, Options.font.size, Options.font.flags)
	--hp player deficit text
		MP_PLAYER_DEFICIT:SetFont(Options.font.font, Options.font.size, Options.font.flags)
	end
end
------------------------------------------------------------------------------------------------------------------
function Load_HP_Target()
	if (event=="ADDON_LOADED") and (arg1=="gHUD") then	
	--set position
		HP_TARGET_FRAME:ClearAllPoints()
		HP_TARGET_FRAME:SetPoint("BOTTOM", HP_PLAYER_FRAME, "BOTTOM", Options.targetPosX, Options.targetPosY)
	--texture
		HP_TARGET_BAR_TEXTURE:SetTexture(Options.texture.BarHeight)
		
		HP_TARGET_BG_TEXTURE1:SetHeight(Options.bgHeight)
		HP_TARGET_BG_TEXTURE1:SetWidth(Options.bgWidth)
		HP_TARGET_BG_TEXTURE2:SetHeight(Options.bgHeight-2)
		HP_TARGET_BG_TEXTURE2:SetWidth(Options.bgWidth-2)
		HP_TARGET_BG_TEXTURE2:SetVertexColor(0,0,0,Colors.hp100.a)
		
		HP_TARGET_BAR:SetWidth(Options.barWidth)
		HP_TARGET_FRAME:SetHeight(Options.bgHeight)
		HP_TARGET_FRAME:SetWidth(Options.bgWidth)
		
		HP_Target_Button:SetHeight(Options.bgHeight)
		HP_Target_Button:SetWidth(Options.bgWidth)
	--hp target max text
		HP_TARGET_MAX:SetFont(Options.font.font, Options.font.size, Options.font.flags)
		HP_TARGET_MAX:SetTextColor(0, 1, 0, 1)
	--hp target current text
		HP_TARGET_CURRENT:SetFont(Options.font.font, Options.font.size, Options.font.flags)
	--hp target percent text
		HP_TARGET_PERCENT:SetFont(Options.font.font, Options.font.size, Options.font.flags)
	--hp target deficit text
		HP_TARGET_DEFICIT:SetFont(Options.font.font, Options.font.size, Options.font.flags)
	end
end
---------------------------------------------------------
function Load_MP_Target()
	if (event=="ADDON_LOADED") and (arg1=="gHUD") then	
	--set position
		MP_TARGET_FRAME:ClearAllPoints()
		MP_TARGET_FRAME:SetPoint("BOTTOM", MP_PLAYER_FRAME, "BOTTOM", -Options.targetPosX, Options.targetPosY)
	--texture
		MP_TARGET_BAR_TEXTURE:SetTexture(Options.texture.BarHeight)
		
		MP_TARGET_BG_TEXTURE1:SetHeight(Options.bgHeight)
		MP_TARGET_BG_TEXTURE1:SetWidth(Options.bgWidth)
		MP_TARGET_BG_TEXTURE2:SetHeight(Options.bgHeight-2)
		MP_TARGET_BG_TEXTURE2:SetWidth(Options.bgWidth-2)
		MP_TARGET_BG_TEXTURE2:SetVertexColor(0,0,0,Colors.hp100.a)
		
		MP_TARGET_BAR:SetWidth(Options.barWidth)
		MP_TARGET_FRAME:SetHeight(Options.bgHeight)
		MP_TARGET_FRAME:SetWidth(Options.bgWidth)
		
		MP_Target_Button:SetHeight(Options.bgHeight)
		MP_Target_Button:SetWidth(Options.bgWidth)
	--hp target max text
		MP_TARGET_MAX:SetFont(Options.font.font, Options.font.size, Options.font.flags)
	--hp target current text
		MP_TARGET_CURRENT:SetFont(Options.font.font, Options.font.size, Options.font.flags)
	--hp target percent text
		MP_TARGET_PERCENT:SetFont(Options.font.font, Options.font.size, Options.font.flags)
	--hp target deficit text
		MP_TARGET_DEFICIT:SetFont(Options.font.font, Options.font.size, Options.font.flags)
	end
end
------------------------------------------------------------------------------------------------------------------
function Load_HP_Party1()
	if (event=="ADDON_LOADED") and (arg1=="gHUD") then	
		if (Options.showParty==1) then
		--set position
			HP_PARTY1_FRAME:ClearAllPoints()
			HP_PARTY1_FRAME:SetPoint("BOTTOM", HP_PLAYER_FRAME, "BOTTOM", -Options.partyPosX, Options.partyPosY)
		--texture
			HP_PARTY1_BAR_TEXTURE:SetTexture(Options.texture.BarHeight)
		
			HP_PARTY1_BG_TEXTURE1:SetHeight((Options.bgHeight/4)-3)
			HP_PARTY1_BG_TEXTURE1:SetWidth(Options.bgWidth)
			HP_PARTY1_BG_TEXTURE2:SetHeight((Options.bgHeight/4)-5)
			HP_PARTY1_BG_TEXTURE2:SetWidth(Options.bgWidth-2)
			HP_PARTY1_BG_TEXTURE2:SetVertexColor(0,0,0,Colors.hp100.a)
		
			HP_PARTY1_BAR:SetWidth(Options.barWidth)
			HP_PARTY1_FRAME:SetHeight((Options.bgHeight/4)-3)
			HP_PARTY1_FRAME:SetWidth(Options.bgWidth)
			
			HP_Party1_Button:SetHeight((Options.bgHeight/4)-3)
			HP_Party1_Button:SetWidth(Options.bgWidth)
		--hp party1 max text
			HP_PARTY1_MAX:SetFont(Options.font.font, Options.font.size, Options.font.flags)
			HP_PARTY1_MAX:SetTextColor(0, 1, 0, 1)
		--hp party1 current text
			HP_PARTY1_CURRENT:SetFont(Options.font.font, Options.font.size, Options.font.flags)
		--hp party1 percent text
			HP_PARTY1_PERCENT:SetFont(Options.font.font, Options.font.size, Options.font.flags)
		--hp party1 deficit text
			HP_PARTY1_DEFICIT:SetFont(Options.font.font, Options.font.size, Options.font.flags)
		else
			HP_PARTY1_FRAME:Hide()
		end
	end
end
---------------------------------------------------------
function Load_MP_Party1()
	if (event=="ADDON_LOADED") and (arg1=="gHUD") then
		if (Options.showParty==1) then
		--set position
			MP_PARTY1_FRAME:ClearAllPoints()
			MP_PARTY1_FRAME:SetPoint("BOTTOM", MP_PLAYER_FRAME, "BOTTOM", Options.partyPosX, Options.partyPosY)
		--texture
			MP_PARTY1_BAR_TEXTURE:SetTexture(Options.texture.BarHeight)
		
			MP_PARTY1_BG_TEXTURE1:SetHeight((Options.bgHeight/4)-3)
			MP_PARTY1_BG_TEXTURE1:SetWidth(Options.bgWidth)
			MP_PARTY1_BG_TEXTURE2:SetHeight((Options.bgHeight/4)-5)
			MP_PARTY1_BG_TEXTURE2:SetWidth(Options.bgWidth-2)
			MP_PARTY1_BG_TEXTURE2:SetVertexColor(0,0,0,Colors.hp100.a)
		
			MP_PARTY1_BAR:SetWidth(Options.barWidth)
			MP_PARTY1_FRAME:SetHeight((Options.bgHeight/4)-3)
			MP_PARTY1_FRAME:SetWidth(Options.bgWidth)
		
			MP_Party1_Button:SetHeight((Options.bgHeight/4)-3)
			MP_Party1_Button:SetWidth(Options.bgWidth)
		--hp party1 max text
			MP_PARTY1_MAX:SetFont(Options.font.font, Options.font.size, Options.font.flags)
			if (UnitPowerType("party1")==0) then
				MP_PARTY1_MAX:SetTextColor(0, 0, 1, 1)
			elseif (UnitPowerType("party1")==1) then
				MP_PARTY1_MAX:SetTextColor(1, 0, 0, 1)
			elseif (UnitPowerType("party1")==2) then
				MP_PARTY1_MAX:SetTextColor(1, 1, 0, 1)
			elseif (UnitPowerType("party1")==3) then
				MP_PARTY1_MAX:SetTextColor(1, 1, 0, 1)
			end
		--hp party1 current text
			MP_PARTY1_CURRENT:SetFont(Options.font.font, Options.font.size, Options.font.flags)
		--hp party1 percent text
			MP_PARTY1_PERCENT:SetFont(Options.font.font, Options.font.size, Options.font.flags)
		--hp party1 deficit text
			MP_PARTY1_DEFICIT:SetFont(Options.font.font, Options.font.size, Options.font.flags)
		else
			MP_PARTY1_FRAME:Hide()
		end
	end
end
------------------------------------------------------------------------------------------------------------------
function Load_HP_Party2()
	if (event=="ADDON_LOADED") and (arg1=="gHUD") then	
		if (Options.showParty==1) then
		--texture
			HP_PARTY2_BAR_TEXTURE:SetTexture(Options.texture.BarHeight)
		
			HP_PARTY2_BG_TEXTURE1:SetHeight((Options.bgHeight/4)-3)
			HP_PARTY2_BG_TEXTURE1:SetWidth(Options.bgWidth)
			HP_PARTY2_BG_TEXTURE2:SetHeight((Options.bgHeight/4)-5)
			HP_PARTY2_BG_TEXTURE2:SetWidth(Options.bgWidth-2)
			HP_PARTY2_BG_TEXTURE2:SetVertexColor(0,0,0,Colors.hp100.a)
		
			HP_PARTY2_BAR:SetWidth(Options.barWidth)
			HP_PARTY2_FRAME:SetHeight((Options.bgHeight/4)-3)
			HP_PARTY2_FRAME:SetWidth(Options.bgWidth)
			
			HP_Party2_Button:SetHeight((Options.bgHeight/4)-3)
			HP_Party2_Button:SetWidth(Options.bgWidth)
		--hp party2 max text
			HP_PARTY2_MAX:SetFont(Options.font.font, Options.font.size, Options.font.flags)
			HP_PARTY2_MAX:SetTextColor(0, 1, 0, 1)
		--hp party2 current text
			HP_PARTY2_CURRENT:SetFont(Options.font.font, Options.font.size, Options.font.flags)
		--hp party2 percent text
			HP_PARTY2_PERCENT:SetFont(Options.font.font, Options.font.size, Options.font.flags)
		--hp party2 deficit text
			HP_PARTY2_DEFICIT:SetFont(Options.font.font, Options.font.size, Options.font.flags)
		else
			HP_PARTY2_FRAME:Hide()
		end
	end
end
---------------------------------------------------------
function Load_MP_Party2()
	if (event=="ADDON_LOADED") and (arg1=="gHUD") then
		if (Options.showParty==1) then	
		--texture
			MP_PARTY2_BAR_TEXTURE:SetTexture(Options.texture.BarHeight)
		
			MP_PARTY2_BG_TEXTURE1:SetHeight((Options.bgHeight/4)-3)
			MP_PARTY2_BG_TEXTURE1:SetWidth(Options.bgWidth)
			MP_PARTY2_BG_TEXTURE2:SetHeight((Options.bgHeight/4)-5)
			MP_PARTY2_BG_TEXTURE2:SetWidth(Options.bgWidth-2)
			MP_PARTY2_BG_TEXTURE2:SetVertexColor(0,0,0,Colors.hp100.a)
		
			MP_PARTY2_BAR:SetWidth(Options.barWidth)
			MP_PARTY2_FRAME:SetHeight((Options.bgHeight/4)-3)
			MP_PARTY2_FRAME:SetWidth(Options.bgWidth)
		
			MP_Party2_Button:SetHeight((Options.bgHeight/4)-3)
			MP_Party2_Button:SetWidth(Options.bgWidth)
		--hp party2 max text
			MP_PARTY2_MAX:SetFont(Options.font.font, Options.font.size, Options.font.flags)
			if (UnitPowerType("party2")==0) then
				MP_PARTY2_MAX:SetTextColor(0, 0, 1, 1)
			elseif (UnitPowerType("party2")==1) then
				MP_PARTY2_MAX:SetTextColor(1, 0, 0, 1)
			elseif (UnitPowerType("party2")==2) then
				MP_PARTY2_MAX:SetTextColor(1, 1, 0, 1)
			elseif (UnitPowerType("party2")==3) then
				MP_PARTY2_MAX:SetTextColor(1, 1, 0, 1)
			end
		--hp party2 current text
			MP_PARTY2_CURRENT:SetFont(Options.font.font, Options.font.size, Options.font.flags)
		--hp party2 percent text
			MP_PARTY2_PERCENT:SetFont(Options.font.font, Options.font.size, Options.font.flags)
		--hp party2 deficit text
			MP_PARTY2_DEFICIT:SetFont(Options.font.font, Options.font.size, Options.font.flags)
		else	
			MP_PARTY2_FRAME:Hide()
		end
	end
end
------------------------------------------------------------------------------------------------------------------
function Load_HP_Party3()
	if (event=="ADDON_LOADED") and (arg1=="gHUD") then	
		if (Options.showParty==1) then
		--texture
			HP_PARTY3_BAR_TEXTURE:SetTexture(Options.texture.BarHeight)
		
			HP_PARTY3_BG_TEXTURE1:SetHeight((Options.bgHeight/4)-3)
			HP_PARTY3_BG_TEXTURE1:SetWidth(Options.bgWidth)
			HP_PARTY3_BG_TEXTURE2:SetHeight((Options.bgHeight/4)-5)
			HP_PARTY3_BG_TEXTURE2:SetWidth(Options.bgWidth-2)
			HP_PARTY3_BG_TEXTURE2:SetVertexColor(0,0,0,Colors.hp100.a)
		
			HP_PARTY3_BAR:SetWidth(Options.barWidth)
			HP_PARTY3_FRAME:SetHeight((Options.bgHeight/4)-3)
			HP_PARTY3_FRAME:SetWidth(Options.bgWidth)
			
			HP_Party3_Button:SetHeight((Options.bgHeight/4)-3)
			HP_Party3_Button:SetWidth(Options.bgWidth)
		--hp party3 max text
			HP_PARTY3_MAX:SetFont(Options.font.font, Options.font.size, Options.font.flags)
			HP_PARTY3_MAX:SetTextColor(0, 1, 0, 1)
		--hp party3 current text
			HP_PARTY3_CURRENT:SetFont(Options.font.font, Options.font.size, Options.font.flags)
		--hp party3 percent text
			HP_PARTY3_PERCENT:SetFont(Options.font.font, Options.font.size, Options.font.flags)
		--hp party3 deficit text
			HP_PARTY3_DEFICIT:SetFont(Options.font.font, Options.font.size, Options.font.flags)
		else
			HP_PARTY3_FRAME:Hide()
		end
	end
end
---------------------------------------------------------
function Load_MP_Party3()
	if (event=="ADDON_LOADED") and (arg1=="gHUD") then
		if (Options.showParty==1) then
		--texture
			MP_PARTY3_BAR_TEXTURE:SetTexture(Options.texture.BarHeight)
		
			MP_PARTY3_BG_TEXTURE1:SetHeight((Options.bgHeight/4)-3)
			MP_PARTY3_BG_TEXTURE1:SetWidth(Options.bgWidth)
			MP_PARTY3_BG_TEXTURE2:SetHeight((Options.bgHeight/4)-5)
			MP_PARTY3_BG_TEXTURE2:SetWidth(Options.bgWidth-2)
			MP_PARTY3_BG_TEXTURE2:SetVertexColor(0,0,0,Colors.hp100.a)
		
			MP_PARTY3_BAR:SetWidth(Options.barWidth)
			MP_PARTY3_FRAME:SetHeight((Options.bgHeight/4)-3)
			MP_PARTY3_FRAME:SetWidth(Options.bgWidth)
		
			MP_Party3_Button:SetHeight((Options.bgHeight/4)-3)
			MP_Party3_Button:SetWidth(Options.bgWidth)
		--hp party3 max text
			MP_PARTY3_MAX:SetFont(Options.font.font, Options.font.size, Options.font.flags)
			if (UnitPowerType("party3")==0) then
				MP_PARTY3_MAX:SetTextColor(0, 0, 1, 1)
			elseif (UnitPowerType("party3")==1) then
				MP_PARTY3_MAX:SetTextColor(1, 0, 0, 1)
			elseif (UnitPowerType("party3")==2) then
				MP_PARTY3_MAX:SetTextColor(1, 1, 0, 1)
			elseif (UnitPowerType("party3")==3) then
				MP_PARTY3_MAX:SetTextColor(1, 1, 0, 1)
			end
		--hp party3 current text
			MP_PARTY3_CURRENT:SetFont(Options.font.font, Options.font.size, Options.font.flags)
		--hp party3 percent text
			MP_PARTY3_PERCENT:SetFont(Options.font.font, Options.font.size, Options.font.flags)
		--hp party3 deficit text
			MP_PARTY3_DEFICIT:SetFont(Options.font.font, Options.font.size, Options.font.flags)
		else 
			MP_PARTY3_FRAME:Hide()
		end
	end
end
------------------------------------------------------------------------------------------------------------------
function Load_HP_Party4()
	if (event=="ADDON_LOADED") and (arg1=="gHUD") then	
		if (Options.showParty==1) then
		--texture
			HP_PARTY4_BAR_TEXTURE:SetTexture(Options.texture.BarHeight)
		
			HP_PARTY4_BG_TEXTURE1:SetHeight((Options.bgHeight/4)-3)
			HP_PARTY4_BG_TEXTURE1:SetWidth(Options.bgWidth)
			HP_PARTY4_BG_TEXTURE2:SetHeight((Options.bgHeight/4)-5)
			HP_PARTY4_BG_TEXTURE2:SetWidth(Options.bgWidth-2)
			HP_PARTY4_BG_TEXTURE2:SetVertexColor(0,0,0,Colors.hp100.a)
		
			HP_PARTY4_BAR:SetWidth(Options.barWidth)
			HP_PARTY4_FRAME:SetHeight((Options.bgHeight/4)-3)
			HP_PARTY4_FRAME:SetWidth(Options.bgWidth)
			
			HP_Party4_Button:SetHeight((Options.bgHeight/4)-3)
			HP_Party4_Button:SetWidth(Options.bgWidth)
		--hp party4 max text
			HP_PARTY4_MAX:SetFont(Options.font.font, Options.font.size, Options.font.flags)
			HP_PARTY4_MAX:SetTextColor(0, 1, 0, 1)
		--hp party4 current text
			HP_PARTY4_CURRENT:SetFont(Options.font.font, Options.font.size, Options.font.flags)
		--hp party4 percent text
			HP_PARTY4_PERCENT:SetFont(Options.font.font, Options.font.size, Options.font.flags)
		--hp party4 deficit text
			HP_PARTY4_DEFICIT:SetFont(Options.font.font, Options.font.size, Options.font.flags)
		else
			HP_PARTY4_FRAME:Hide()
		end
	end
end
---------------------------------------------------------
function Load_MP_Party4()
	if (event=="ADDON_LOADED") and (arg1=="gHUD") then
		if (Options.showParty==1) then	
		--texture
			MP_PARTY4_BAR_TEXTURE:SetTexture(Options.texture.BarHeight)
		
			MP_PARTY4_BG_TEXTURE1:SetHeight((Options.bgHeight/4)-3)
			MP_PARTY4_BG_TEXTURE1:SetWidth(Options.bgWidth)
			MP_PARTY4_BG_TEXTURE2:SetHeight((Options.bgHeight/4)-5)
			MP_PARTY4_BG_TEXTURE2:SetWidth(Options.bgWidth-2)
			MP_PARTY4_BG_TEXTURE2:SetVertexColor(0,0,0,Colors.hp100.a)
		
			MP_PARTY4_BAR:SetWidth(Options.barWidth)
			MP_PARTY4_FRAME:SetHeight((Options.bgHeight/4)-3)
			MP_PARTY4_FRAME:SetWidth(Options.bgWidth)
		
			MP_Party4_Button:SetHeight((Options.bgHeight/4)-3)
			MP_Party4_Button:SetWidth(Options.bgWidth)
		--hp party4 max text
			MP_PARTY4_MAX:SetFont(Options.font.font, Options.font.size, Options.font.flags)
			if (UnitPowerType("party4")==0) then
				MP_PARTY4_MAX:SetTextColor(0, 0, 1, 1)
			elseif (UnitPowerType("party4")==1) then
				MP_PARTY4_MAX:SetTextColor(1, 0, 0, 1)
			elseif (UnitPowerType("party4")==2) then
				MP_PARTY4_MAX:SetTextColor(1, 1, 0, 1)
			elseif (UnitPowerType("party4")==3) then
				MP_PARTY4_MAX:SetTextColor(1, 1, 0, 1)
			end
		--hp party4 current text
			MP_PARTY4_CURRENT:SetFont(Options.font.font, Options.font.size, Options.font.flags)
		--hp party4 percent text
			MP_PARTY4_PERCENT:SetFont(Options.font.font, Options.font.size, Options.font.flags)
		--hp party4 deficit text
			MP_PARTY4_DEFICIT:SetFont(Options.font.font, Options.font.size, Options.font.flags)
		else 
			MP_PARTY4_FRAME:Hide()
		end
	end
end
------------------------------------------------------------------------------------------------------------------
function Load_HP_Pet()
	if (event=="ADDON_LOADED") and (arg1=="gHUD") then
		if (Options.showPet==1) then
		--set position
			HP_PET_FRAME:ClearAllPoints()
			HP_PET_FRAME:SetPoint("BOTTOM", HP_PARTY1_FRAME, "BOTTOM", -Options.petPosX, Options.petPosY)
		--texture
			HP_PET_BAR_TEXTURE:SetTexture(Options.texture.BarHeight)
		
			HP_PET_BG_TEXTURE1:SetHeight(Options.bgHeight/2)
			HP_PET_BG_TEXTURE1:SetWidth(Options.bgWidth)
			HP_PET_BG_TEXTURE2:SetHeight((Options.bgHeight/2)-2)
			HP_PET_BG_TEXTURE2:SetWidth(Options.bgWidth-2)
			HP_PET_BG_TEXTURE2:SetVertexColor(0,0,0,Colors.hp100.a)
		
			HP_PET_BAR:SetWidth(Options.barWidth)
			HP_PET_FRAME:SetHeight(Options.bgHeight/2)
			HP_PET_FRAME:SetWidth(Options.bgWidth)
			
			HP_Pet_Button:SetHeight(Options.bgHeight/2)
			HP_Pet_Button:SetWidth(Options.bgWidth)
		--hp pet max text
			HP_PET_MAX:SetFont(Options.font.font, Options.font.size, Options.font.flags)
			HP_PET_MAX:SetTextColor(0, 1, 0, 1)
		--hp pet current text
			HP_PET_CURRENT:SetFont(Options.font.font, Options.font.size, Options.font.flags)
		--hp pet percent text
			HP_PET_PERCENT:SetFont(Options.font.font, Options.font.size, Options.font.flags)
		--hp pet deficit text
			HP_PET_DEFICIT:SetFont(Options.font.font, Options.font.size, Options.font.flags)
		else
			HP_PET_FRAME:Hide()
		end
	end
end
---------------------------------------------------------
function Load_MP_Pet()
	if (event=="ADDON_LOADED") and (arg1=="gHUD") then
		if (Options.showPet==1) then
		--set position
			MP_PET_FRAME:ClearAllPoints()
			MP_PET_FRAME:SetPoint("BOTTOM", MP_PARTY1_FRAME, "BOTTOM", Options.petPosX, Options.petPosY)
		--texture
			MP_PET_BAR_TEXTURE:SetTexture(Options.texture.BarHeight)
		
			MP_PET_BG_TEXTURE1:SetHeight(Options.bgHeight/2)
			MP_PET_BG_TEXTURE1:SetWidth(Options.bgWidth)
			MP_PET_BG_TEXTURE2:SetHeight((Options.bgHeight/2)-2)
			MP_PET_BG_TEXTURE2:SetWidth(Options.bgWidth-2)
			MP_PET_BG_TEXTURE2:SetVertexColor(0,0,0,Colors.hp100.a)
		
			MP_PET_BAR:SetWidth(Options.barWidth)
			MP_PET_FRAME:SetHeight(Options.bgHeight/2)
			MP_PET_FRAME:SetWidth(Options.bgWidth)
		
			MP_Pet_Button:SetHeight(Options.bgHeight/2)
			MP_Pet_Button:SetWidth(Options.bgWidth)
		--hp pet max text
			MP_PET_MAX:SetFont(Options.font.font, Options.font.size, Options.font.flags)
		--hp pet current text
			MP_PET_CURRENT:SetFont(Options.font.font, Options.font.size, Options.font.flags)
		--hp pet percent text
			MP_PET_PERCENT:SetFont(Options.font.font, Options.font.size, Options.font.flags)
		--hp pet deficit text
			MP_PET_DEFICIT:SetFont(Options.font.font, Options.font.size, Options.font.flags)
		else 
			MP_PET_FRAME:Hide()
		end
	end
end
------------------------------------------------------------------------------------------------------------------
function Load_HP_TargetTarget()
	if (event=="ADDON_LOADED") and (arg1=="gHUD") then
		if (Options.showTT==1) then
		--set position
			HP_TARGETTARGET_FRAME:ClearAllPoints()
			HP_TARGETTARGET_FRAME:SetPoint("BOTTOM", HP_TARGET_FRAME, "BOTTOM", Options.ttPosX, Options.ttPosY)
		--texture
			HP_TARGETTARGET_BAR_TEXTURE:SetTexture(Options.texture.BarHeight)
		
			HP_TARGETTARGET_BG_TEXTURE1:SetHeight(Options.bgHeight/2)
			HP_TARGETTARGET_BG_TEXTURE1:SetWidth(Options.bgWidth)
			HP_TARGETTARGET_BG_TEXTURE2:SetHeight((Options.bgHeight/2)-2)
			HP_TARGETTARGET_BG_TEXTURE2:SetWidth(Options.bgWidth-2)
			HP_TARGETTARGET_BG_TEXTURE2:SetVertexColor(0,0,0,Colors.hp100.a)
		
			HP_TARGETTARGET_BAR:SetWidth(Options.barWidth)
			HP_TARGETTARGET_FRAME:SetHeight(Options.bgHeight/2)
			HP_TARGETTARGET_FRAME:SetWidth(Options.bgWidth)
		
			HP_TargetTarget_Button:SetHeight(Options.bgHeight/2)
			HP_TargetTarget_Button:SetWidth(Options.bgWidth)
		--hp targettarget max text
			HP_TARGETTARGET_MAX:SetFont(Options.font.font, Options.font.size, Options.font.flags)
			HP_TARGETTARGET_MAX:SetTextColor(0, 1, 0, 1)
		--hp targettarget current text
			HP_TARGETTARGET_CURRENT:SetFont(Options.font.font, Options.font.size, Options.font.flags)
		--hp targettarget percent text
			HP_TARGETTARGET_PERCENT:SetFont(Options.font.font, Options.font.size, Options.font.flags)
		--hp targettarget deficit text
			HP_TARGETTARGET_DEFICIT:SetFont(Options.font.font, Options.font.size, Options.font.flags)
		else
			HP_TARGETTARGET_FRAME:Hide()
		end
	end
end
---------------------------------------------------------
function Load_MP_TargetTarget()
	if (event=="ADDON_LOADED") and (arg1=="gHUD") then
		if (Options.showTT==1) then	
		--set position
			MP_TARGETTARGET_FRAME:ClearAllPoints()
			MP_TARGETTARGET_FRAME:SetPoint("BOTTOM", MP_TARGET_FRAME, "BOTTOM", -Options.ttPosX, Options.ttPosY)
		--texture
			MP_TARGETTARGET_BAR_TEXTURE:SetTexture(Options.texture.BarHeight)
		
			MP_TARGETTARGET_BG_TEXTURE1:SetHeight(Options.bgHeight/2)
			MP_TARGETTARGET_BG_TEXTURE1:SetWidth(Options.bgWidth)
			MP_TARGETTARGET_BG_TEXTURE2:SetHeight((Options.bgHeight/2)-2)
			MP_TARGETTARGET_BG_TEXTURE2:SetWidth(Options.bgWidth-2)
			MP_TARGETTARGET_BG_TEXTURE2:SetVertexColor(0,0,0,Colors.hp100.a)
		
			MP_TARGETTARGET_BAR:SetWidth(Options.barWidth)
			MP_TARGETTARGET_FRAME:SetHeight(Options.bgHeight/2)
			MP_TARGETTARGET_FRAME:SetWidth(Options.bgWidth)
			
			MP_TargetTarget_Button:SetHeight(Options.bgHeight/2)
			MP_TargetTarget_Button:SetWidth(Options.bgWidth)
		--hp targettarget max text
			MP_TARGETTARGET_MAX:SetFont(Options.font.font, Options.font.size, Options.font.flags)
		--hp targettarget current text
			MP_TARGETTARGET_CURRENT:SetFont(Options.font.font, Options.font.size, Options.font.flags)
		--hp targettarget percent text
			MP_TARGETTARGET_PERCENT:SetFont(Options.font.font, Options.font.size, Options.font.flags)
		--hp targettarget deficit text
			MP_TARGETTARGET_DEFICIT:SetFont(Options.font.font, Options.font.size, Options.font.flags)
		else
			MP_TARGETTARGET_FRAME:Hide()
		end
	end
end
------------------------------------------------------------------------------------------------------------------
function HP_Player(arg1)
	this.TimeSinceLastUpdate=this.TimeSinceLastUpdate + arg1
	if (this.TimeSinceLastUpdate > Options.update) then	
	local cur, max = UnitHealth("player"), UnitHealthMax("player")
	local deficit = max-cur
	--hp player bar
		if (cur==0) then
			HP_PLAYER_BAR:SetHeight(1)
		else
			HP_PLAYER_BAR:SetHeight(Options.bgHeight/max*cur)
			HP_Player_Color()
		end
	--hp player max text
		HP_PLAYER_MAX:SetText(max)
	--hp player current text
		HP_PLAYER_CURRENT:SetText(cur)
	--hp player percent text
		HP_PLAYER_PERCENT:SetText(string.format("%.0f", (100/max*cur)) .."%")
	--hp player deficit text
		if (cur/max)>0.9
		or (cur/max)<0.1
		or UnitInParty("party1") and (Options.showParty==1) then
			HP_PLAYER_DEFICIT:Hide() 
		else
			HP_PLAYER_DEFICIT:Show()
			if (Options.defFormat==0) then
				HP_PLAYER_DEFICIT:SetText("-" ..deficit)
			elseif (Options.defFormat==1) then		
				HP_PLAYER_DEFICIT:SetText(string.format("-%.1f", (deficit/1000)))
			end
		end
		this.TimeSinceLastUpdate=0
	end
end
---------------------------------------------------------
function MP_Player(arg1)
	this.TimeSinceLastUpdate=this.TimeSinceLastUpdate + arg1
	if (this.TimeSinceLastUpdate > Options.update) then	
	local cur, max = UnitMana("player"), UnitManaMax("player")
	local deficit = max-cur
	--mp player bar
		if (cur==0) then
			MP_PLAYER_BAR:SetHeight(1)
		else
			MP_PLAYER_BAR:SetHeight(Options.bgHeight/max*cur)
			MP_Player_Color()
		end
	--mp player max text
		MP_PLAYER_MAX:SetText(max)
	--mp player current text
		MP_PLAYER_CURRENT:SetText(cur)
	--mp player percent text
		MP_PLAYER_PERCENT:SetText(string.format("%.0f", (100/max*cur)) .."%")
	--mp player deficit text
		if (cur/max)>0.9
		or (cur/max)<0.1 
		or UnitInParty("party1") and (Options.showParty==1) then 
			MP_PLAYER_DEFICIT:Hide()
		else
			if (UnitPowerType("player")==0) then
				MP_PLAYER_DEFICIT:Show()
				if (Options.defFormat==0) then
					MP_PLAYER_DEFICIT:SetText("-" ..deficit)
				elseif 	(Options.defFormat==1) then
					MP_PLAYER_DEFICIT:SetText(string.format("-%.1f", (deficit/1000)))
				end
			elseif (UnitPowerType("player")==1)
				or (UnitPowerType("player")==2)
				or (UnitPowerType("player")==3) then
					MP_PLAYER_DEFICIT:Show()
					MP_PLAYER_DEFICIT:SetText(cur)
			end
		end
		this.TimeSinceLastUpdate=0
	end
end
---------------------------------------------------------
function HP_Target(arg1)
	this.TimeSinceLastUpdate=this.TimeSinceLastUpdate + arg1
	if (this.TimeSinceLastUpdate > Options.update) then
		if (UnitExists("target")) then
		--MobHealth
			local cur, max, found
			local deficit
			if MobHealth3 then
				cur, max, found = MobHealth3:GetUnitHealth("target", UnitHealth("target"), UnitHealthMax("target"))
				deficit = max-cur
			else
				cur, max = UnitHealth("target"), UnitHealthMax("target")
				deficit = max-cur
			end
		--targettarget	
			if (Options.showTT==1) 
			and (UnitExists("targettarget")) then
				RegisterUnitWatch(HP_TARGETTARGET_FRAME)
				RegisterUnitWatch(HP_TargetTarget_Button)
				HP_TARGETTARGET_FRAME:Show()
			else 
				UnregisterUnitWatch(HP_TARGETTARGET_FRAME)
				UnregisterUnitWatch(HP_TargetTarget_Button)
				HP_TARGETTARGET_FRAME:Hide()
			end
		--hp target bar
			if (UnitHealth("target")==0) then
				HP_TARGET_BAR:SetHeight(1)
			else
				if (max>=cur) then
					HP_TARGET_BAR:SetHeight(Options.bgHeight/max*cur)
					HP_Target_Color()	
				end
			end
		--hp target max text
			HP_TARGET_MAX:SetText(max)
		--hp target current text
			HP_TARGET_CURRENT:SetText(cur)
		--hp target percent text
			HP_TARGET_PERCENT:SetText(string.format("%.0f", (100/max*cur)) .."%")
		--hp target deficit text
			if (cur/max)>0.9
			or (cur/max)<0.1 then
				HP_TARGET_DEFICIT:Hide() 
			else
				HP_TARGET_DEFICIT:Show()
				if (Options.defFormat==0) then
					HP_TARGET_DEFICIT:SetText("-" ..deficit)
				elseif (Options.defFormat==1) then		
					HP_TARGET_DEFICIT:SetText(string.format("-%.1f", (deficit/1000)))
				end
			end
		end
		this.TimeSinceLastUpdate=0
	end
end
---------------------------------------------------------
function MP_Target(arg1)
	this.TimeSinceLastUpdate=this.TimeSinceLastUpdate + arg1
	if (this.TimeSinceLastUpdate > Options.update) then	
		if (UnitExists("target")) then	
		local cur, max = UnitMana("target"), UnitManaMax("target")
		local deficit = max-cur
			if (Options.showTT==1)
			and (UnitExists("targettarget")) then
				if (UnitIsPlayer("targettarget")==nil) 
				and (UnitPowerType("targettarget")==1)  then
					UnregisterUnitWatch(MP_TARGETTARGET_FRAME)
					UnregisterUnitWatch(MP_TargetTarget_Button)
					MP_TARGETTARGET_FRAME:Hide()
				else
					RegisterUnitWatch(MP_TARGETTARGET_FRAME)
					RegisterUnitWatch(MP_TargetTarget_Button)
					MP_TARGETTARGET_FRAME:Show()
					MP_TargetTarget_Color()
				end
			else 
				UnregisterUnitWatch(MP_TARGETTARGET_FRAME)
				UnregisterUnitWatch(MP_TargetTarget_Button)
				MP_TARGETTARGET_FRAME:Hide()
			end	
		--mp target bar
			if (cur==0) then
				MP_TARGET_BAR:SetHeight(1)
			else
				if (max>=cur) then
					MP_TARGET_BAR:SetHeight(Options.bgHeight/max*cur)
					MP_Target_Color()
				end
			end
		--mp target max text
			MP_TARGET_MAX:SetText(UnitManaMax("target"))
			if (UnitPowerType("target")==0) then
				MP_TARGET_MAX:SetTextColor(0, 0, 1, 1)
			elseif (UnitPowerType("target")==1) then
				MP_TARGET_MAX:SetTextColor(1, 0, 0, 1)
			elseif (UnitPowerType("target")==2) then
				MP_TARGET_MAX:SetTextColor(1, 1, 0, 1)
			elseif (UnitPowerType("target")==3) then
				MP_TARGET_MAX:SetTextColor(1, 1, 0, 1)
			end
		--mp target current text
			MP_TARGET_CURRENT:SetText(cur)
		--mp target percent text
			MP_TARGET_PERCENT:SetText(string.format("%.0f", (100/max*cur)) .."%")
		--mp target deficit text
			if (cur/max)>0.9
			or (cur/max)<0.1 then 
				MP_TARGET_DEFICIT:Hide()
			else
				if (UnitPowerType("target")==0) then
					MP_TARGET_DEFICIT:Show()
					if (Options.defFormat==0) then
						MP_TARGET_DEFICIT:SetText("-" ..deficit)
					elseif (Options.defFormat==1) then	
						MP_TARGET_DEFICIT:SetText(string.format("-%.1f", (deficit/1000)))
					end
				elseif (UnitPowerType("target")==1)
					or (UnitPowerType("target")==2)
					or (UnitPowerType("target")==3) then
						MP_TARGET_DEFICIT:Show()
						MP_TARGET_DEFICIT:SetText(cur)
				end
			end
		end
		this.TimeSinceLastUpdate=0
	end
end
---------------------------------------------------------
function HP_Party1(arg1)
	if (Options.showParty==1) then
		this.TimeSinceLastUpdate=this.TimeSinceLastUpdate + arg1
		if (this.TimeSinceLastUpdate > Options.update) then
			if (UnitExists("party1")) then	
			local cur, max = UnitHealth("party1"), UnitHealthMax("party1")
			local deficit = max-cur
			--hp party1 bar
				if (cur==0) then
					HP_PARTY1_BAR:SetHeight(1)
				else
					if (max>=cur) then
						HP_PARTY1_BAR:SetHeight(((Options.bgHeight/4)-3)/max*cur)
						HP_Party1_Color()
					else 
						HP_PARTY1_BAR:SetHeight((Options.bgHeight/4)-3)
					end
				end
			--hp party1 max text
				HP_PARTY1_MAX:Hide()
			--hp party1 current text
				HP_PARTY1_CURRENT:Hide()
			--hp party1 percent text
				HP_PARTY1_PERCENT:Hide()
			--hp party1 deficit text
				if (cur/max)>0.9
				or (cur/max)<0.1 then
					HP_PARTY1_DEFICIT:Hide() 
				else
					HP_PARTY1_DEFICIT:Show()
				--defmode deficit
					if (Options.defMode==1) then
						if (Options.defFormat==0) then
							HP_PARTY1_DEFICIT:SetText("-" ..deficit)
						elseif (Options.defFormat==1) then		
							HP_PARTY1_DEFICIT:SetText(string.format("-%.1f", (deficit/1000)))
						end
				--defmode current
					elseif (Options.defMode==0) then
						if (Options.defFormat==0) then
							HP_PARTY1_DEFICIT:SetText(cur)
						elseif (Options.defFormat==1) then		
							HP_PARTY1_DEFICIT:SetText(string.format("%.1f", (cur/1000)))
						end
					end
				end
			end
			this.TimeSinceLastUpdate=0
		end	
	else
		HP_PARTY1_FRAME:Hide()
	end
end
---------------------------------------------------------
function MP_Party1(arg1)
	if (Options.showParty==1) then
		this.TimeSinceLastUpdate=this.TimeSinceLastUpdate + arg1
		if (this.TimeSinceLastUpdate > Options.update) then	
			if (UnitExists("party1")) then	
			local cur, max = UnitMana("party1"), UnitManaMax("party1")
			local deficit = max-cur
			--mp party1 bar
				if (cur==0) then
					MP_PARTY1_BAR:SetHeight(1)
				else
					if (max>=cur) then
						MP_PARTY1_BAR:SetHeight(((Options.bgHeight/4)-3)/max*cur)
						MP_Party1_Color()
					else
						MP_PARTY1_BAR:SetHeight((Options.bgHeight/4)-3)
					end
				end
			--mp party1 max text
				MP_PARTY1_MAX:Hide()
			--mp party1 current text
				MP_PARTY1_CURRENT:Hide()
			--mp party1 percent text
				MP_PARTY1_PERCENT:Hide()
			--mp party1 deficit text
				if (cur/max)>0.9
				or (cur/max)<0.1 then 
					MP_PARTY1_DEFICIT:Hide()
				else
					if (UnitPowerType("party1")==0) then
						MP_PARTY1_DEFICIT:Show()
					--defmode deficit
						if (Options.defMode==1) then
							if (Options.defFormat==0) then
								MP_PARTY1_DEFICIT:SetText("-" ..deficit)
							elseif (Options.defFormat==1) then		
								MP_PARTY1_DEFICIT:SetText(string.format("-%.1f", (deficit/1000)))
							end
					--defmode current
						elseif (Options.defMode==0) then
							if (Options.defFormat==0) then
								MP_PARTY1_DEFICIT:SetText(UnitMana("party1"))
							elseif (Options.defFormat==1) then		
								MP_PARTY1_DEFICIT:SetText(string.format("%.1f", (cur/1000)))
							end
						end
					elseif (UnitPowerType("party1")==1)
						or (UnitPowerType("party1")==2)
						or (UnitPowerType("party1")==3) then
							MP_PARTY1_DEFICIT:Show()
							MP_PARTY1_DEFICIT:SetText(cur)
					end
				end
			end
			this.TimeSinceLastUpdate=0
		end
	else
		MP_PARTY1_FRAME:Hide()
	end
end
---------------------------------------------------------
function HP_Party2(arg1)
	if (Options.showParty==1) then
		this.TimeSinceLastUpdate=this.TimeSinceLastUpdate + arg1
		if (this.TimeSinceLastUpdate > Options.update) then
			if (UnitExists("party2")) then
			local cur, max = UnitHealth("party2"), UnitHealthMax("party2")
			local deficit = max-cur	
			--hp party2 bar
				if (cur==0) then
					HP_PARTY2_BAR:SetHeight(1)
				else
					if (max>=cur) then
						HP_PARTY2_BAR:SetHeight(((Options.bgHeight/4)-3)/max*cur)
						HP_Party2_Color()
					else
						HP_PARTY2_BAR:SetHeight((Options.bgHeight/4)-3)
					end
				end
			--hp party2 max text
				HP_PARTY2_MAX:Hide()
			--hp party2 current text
				HP_PARTY2_CURRENT:Hide()
			--hp party2 percent text
				HP_PARTY2_PERCENT:Hide()
			--hp party2 deficit text
				if (cur/max)>0.9
				or (cur/max)<0.1 then
					HP_PARTY2_DEFICIT:Hide() 
				else
					HP_PARTY2_DEFICIT:Show()
				--defmode deficit
					if (Options.defMode==1) then	
						if (Options.defFormat==0) then
							HP_PARTY2_DEFICIT:SetText("-" ..deficit)
						elseif (Options.defFormat==1) then		
							HP_PARTY2_DEFICIT:SetText(string.format("-%.1f", (deficit/1000)))
						end
				--defmode current
					elseif (Options.defMode==0) then
						if (Options.defFormat==0) then
							HP_PARTY2_DEFICIT:SetText(cur)
						elseif (Options.defFormat==1) then		
							HP_PARTY2_DEFICIT:SetText(string.format("%.1f", (cur/1000)))
						end
					end
				end
			end
			this.TimeSinceLastUpdate=0
		end
	else
		HP_PARTY2_FRAME:Hide()
	end
end
---------------------------------------------------------
function MP_Party2(arg1)
	if (Options.showParty==1) then
		this.TimeSinceLastUpdate=this.TimeSinceLastUpdate + arg1
		if (this.TimeSinceLastUpdate > Options.update) then	
			if (UnitExists("party2")) then	
			local cur, max = UnitMana("party2"), UnitManaMax("party2")
			local deficit = max-cur	
			--mp party2 bar
				if (cur==0) then
					MP_PARTY2_BAR:SetHeight(1)
				else
					if (max>=cur) then
						MP_PARTY2_BAR:SetHeight(((Options.bgHeight/4)-3)/max*cur)
						MP_Party2_Color()
					else
						MP_PARTY2_BAR:SetHeight((Options.bgHeight/4)-3)
					end
				end
			--mp party2 max text
				MP_PARTY2_MAX:Hide()
			--mp party2 current text
				MP_PARTY2_CURRENT:Hide()
			--mp party2 percent text
				MP_PARTY2_PERCENT:Hide()
			--mp party2 deficit text
				if (UnitMana("party2")/UnitManaMax("party2"))>0.9
				or (UnitMana("party2")/UnitManaMax("party2"))<0.1 then 
					MP_PARTY2_DEFICIT:Hide()
				else
					if (UnitPowerType("party2")==0) then
						MP_PARTY2_DEFICIT:Show()
					--defmode deficit
						if (Options.defMode==1) then
							if (Options.defFormat==0) then
								MP_PARTY2_DEFICIT:SetText("-" ..deficit)
							elseif (Options.defFormat==1) then		
								MP_PARTY2_DEFICIT:SetText(string.format("-%.1f", (deficit/1000)))
							end
					--defmode current
						elseif (Options.defMode==0) then
							if (Options.defFormat==0) then
								MP_PARTY2_DEFICIT:SetText(cur)
							elseif (Options.defFormat==1) then		
								MP_PARTY2_DEFICIT:SetText(string.format("%.1f", (cur/1000)))
							end
						end
					elseif (UnitPowerType("party2")==1)
						or (UnitPowerType("party2")==2)
						or (UnitPowerType("party2")==3) then
							MP_PARTY2_DEFICIT:Show()
							MP_PARTY2_DEFICIT:SetText(cur)
					end
				end
			end
			this.TimeSinceLastUpdate=0
		end
	else
		MP_PARTY2_FRAME:Hide()
	end
end
---------------------------------------------------------
function HP_Party3(arg1)
	if (Options.showParty==1) then
		this.TimeSinceLastUpdate=this.TimeSinceLastUpdate + arg1
		if (this.TimeSinceLastUpdate > Options.update) then
			if (UnitExists("party3")) then	
			local cur, max = UnitHealth("party3"), UnitHealthMax("party3")
			local deficit = max-cur
			--hp party3 bar
				if (cur==0) then
					HP_PARTY3_BAR:SetHeight(1)
				else
					if (max>=cur) then
						HP_PARTY3_BAR:SetHeight(((Options.bgHeight/4)-3)/max*cur)
						HP_Party3_Color()
					else
						HP_PARTY3_BAR:SetHeight((Options.bgHeight/4)-3)
					end
				end
			--hp party3 max text
				HP_PARTY3_MAX:Hide()
			--hp party3 current text
				HP_PARTY3_CURRENT:Hide()
			--hp party3 percent text
				HP_PARTY3_PERCENT:Hide()
			--hp party3 deficit text
				if (cur/max)>0.9
				or (cur/max)<0.1 then
					HP_PARTY3_DEFICIT:Hide() 
				else
					HP_PARTY3_DEFICIT:Show()
				--defmode deficit
					if (Options.defMode==1) then
						if (Options.defFormat==0) then
							HP_PARTY3_DEFICIT:SetText("-" ..deficit)
						elseif (Options.defFormat==1) then		
							HP_PARTY3_DEFICIT:SetText(string.format("-%.1f", (deficit/1000)))
						end
				--defmode current
					elseif (Options.defMode==0) then
						if (Options.defFormat==0) then
							HP_PARTY3_DEFICIT:SetText(cur)
						elseif (Options.defFormat==1) then		
							HP_PARTY3_DEFICIT:SetText(string.format("%.1f", (cur/1000)))
						end
					end
				end
			end
			this.TimeSinceLastUpdate=0
		end
	else
		HP_PARTY3_FRAME:Hide()
	end
end
---------------------------------------------------------
function MP_Party3(arg1)
	if (Options.showParty==1) then
		this.TimeSinceLastUpdate=this.TimeSinceLastUpdate + arg1
		if (this.TimeSinceLastUpdate > Options.update) then	
			if (UnitExists("party3")) then	
			local cur, max = UnitMana("party3"), UnitManaMax("party3")
			local deficit = max-cur	
			--mp party3 bar
				if (cur==0) then
					MP_PARTY3_BAR:SetHeight(1)
				else
					if (max>=cur) then
						MP_PARTY3_BAR:SetHeight(((Options.bgHeight/4)-3)/max*cur)
						MP_Party3_Color()
					else
						MP_PARTY3_BAR:SetHeight((Options.bgHeight/4)-3)
					end
				end
			--mp party3 max text
				MP_PARTY3_MAX:Hide()
			--mp party3 current text
				MP_PARTY3_CURRENT:Hide()
			--mp party3 percent text
				MP_PARTY3_PERCENT:Hide()
			--mp party3 deficit text
				if (cur/max)>0.9
				or (cur/max)<0.1 then 
					MP_PARTY3_DEFICIT:Hide()
				else
					if (UnitPowerType("party3")==0) then
						MP_PARTY3_DEFICIT:Show()
					--defmode deficit
						if (Options.defMode==1) then
							if (Options.defFormat==0) then
								MP_PARTY3_DEFICIT:SetText("-" ..deficit)
							elseif (Options.defFormat==1) then		
								MP_PARTY3_DEFICIT:SetText(string.format("-%.1f", (deficit/1000)))
							end
					--defmode current
						elseif (Options.defMode==0) then
							if (Options.defFormat==0) then
								MP_PARTY3_DEFICIT:SetText(cur)
							elseif (Options.defFormat==1) then		
								MP_PARTY3_DEFICIT:SetText(string.format("%.1f", (cur/1000)))
							end
						end
					elseif (UnitPowerType("party3")==1)
						or (UnitPowerType("party3")==2)
						or (UnitPowerType("party3")==3) then
							MP_PARTY3_DEFICIT:Show()
							MP_PARTY3_DEFICIT:SetText(cur)
					end
				end
			end
			this.TimeSinceLastUpdate=0
		end
	else
		MP_PARTY3_FRAME:Hide()
	end
end
---------------------------------------------------------
function HP_Party4(arg1)
	if (Options.showParty==1) then
		this.TimeSinceLastUpdate=this.TimeSinceLastUpdate + arg1
		if (this.TimeSinceLastUpdate > Options.update) then
			if (UnitExists("party4")) then
			local cur, max = UnitHealth("party4"), UnitHealthMax("party4")
			local deficit = max-cur
			--hp party4 bar
				if (cur==0) then
					HP_PARTY4_BAR:SetHeight(1)
				else
					if (max>=cur) then
						HP_PARTY4_BAR:SetHeight(((Options.bgHeight/4)-3)/max*cur)
						HP_Party4_Color()
					else
						HP_PARTY4_BAR:SetHeight((Options.bgHeight/4)-3)
					end
				end
			--hp party4 max text
				HP_PARTY4_MAX:Hide()
			--hp party4 current text
				HP_PARTY4_CURRENT:Hide()
			--hp party4 percent text
				HP_PARTY4_PERCENT:Hide()
			--hp party4 deficit text
				if (cur/max)>0.9
				or (cur/max)<0.1 then
					HP_PARTY4_DEFICIT:Hide() 
				else
					HP_PARTY4_DEFICIT:Show()
				--defmode deficit
					if (Options.defMode==1) then
						if (Options.defFormat==0) then
							HP_PARTY4_DEFICIT:SetText("-" ..deficit)
						elseif (Options.defFormat==1) then		
							HP_PARTY4_DEFICIT:SetText(string.format("-%.1f", (deficit/1000)))
						end
				--defmode current
					elseif (Options.defMode==0) then	
						if (Options.defFormat==0) then
							HP_PARTY4_DEFICIT:SetText(cur)
						elseif (Options.defFormat==1) then		
							HP_PARTY4_DEFICIT:SetText(string.format("%.1f", (cur/1000)))
						end
					end
				end
			end
			this.TimeSinceLastUpdate=0
		end
	else
		HP_PARTY4_FRAME:Hide()
	end
end
---------------------------------------------------------
function MP_Party4(arg1)
	if (Options.showParty==1) then
		this.TimeSinceLastUpdate=this.TimeSinceLastUpdate + arg1
		if (this.TimeSinceLastUpdate > Options.update) then	
			if (UnitExists("party4")) then
			local cur, max = UnitMana("party4"), UnitManaMax("party4")
			local deficit = max-cur		
			--mp party4 bar
				if (cur==0) then
					MP_PARTY4_BAR:SetHeight(1)
				else
					if (max>=cur) then
						MP_PARTY4_BAR:SetHeight(((Options.bgHeight/4)-3)/max*cur)
						MP_Party4_Color()
					else
						MP_PARTY4_BAR:SetHeight((Options.bgHeight/4)-3)
					end
				end
			--mp party4 max text
				MP_PARTY4_MAX:Hide()
			--mp party4 current text
				MP_PARTY4_CURRENT:Hide()
			--mp party4 percent text
				MP_PARTY4_PERCENT:Hide()
			--mp party4 deficit text
				if (cur/max)>0.9
				or (cur/max)<0.1 then 
					MP_PARTY4_DEFICIT:Hide()
				else
					if (UnitPowerType("party4")==0) then
						MP_PARTY4_DEFICIT:Show()
					--defmode deficit
						if (Options.defMode==1) then
							if (Options.defFormat==0) then
								MP_PARTY4_DEFICIT:SetText("-" ..deficit)
							elseif (Options.defFormat==1) then		
								MP_PARTY4_DEFICIT:SetText(string.format("-%.1f", (deficit/1000)))
							end
					--defmode current
						elseif (Options.defMode==0) then
							if (Options.defFormat==0) then
								MP_PARTY4_DEFICIT:SetText(cur)
							elseif (Options.defFormat==1) then		
								MP_PARTY4_DEFICIT:SetText(string.format("-%.1f", (deficit/1000)))
							end
						end
					elseif (UnitPowerType("party4")==1)
						or (UnitPowerType("party4")==2)
						or (UnitPowerType("party4")==3) then
							MP_PARTY4_DEFICIT:Show()
							MP_PARTY4_DEFICIT:SetText(cur)
					end
				end
			end
			this.TimeSinceLastUpdate=0
		end
	else
		MP_PARTY4_FRAME:Hide()
	end
end
---------------------------------------------------------
function HP_Pet(arg1)
	if (Options.showPet==1) then
		this.TimeSinceLastUpdate=this.TimeSinceLastUpdate + arg1
		if (this.TimeSinceLastUpdate > Options.update) then
			if (UnitExists("pet")) then	
			local cur, max = UnitHealth("pet"), UnitHealthMax("pet")
			local deficit = max-cur
			--hp pet bar
				if (cur==0) then
					HP_PET_BAR:SetHeight(1)
				else
					HP_PET_BAR:SetHeight((Options.bgHeight/2)/max*cur)
					HP_Pet_Color()
				end
			--hp pet max text
				HP_PET_MAX:SetText(UnitHealthMax("pet"))
			--hp pet current text
				HP_PET_CURRENT:SetText(UnitHealth("pet"))
			--hp pet percent text
				HP_PET_PERCENT:SetText(string.format("%.0f", (100/max*cur)) .."%")
			--hp pet deficit text
				if (cur/max)>0.9
				or (cur/max)<0.1 then
					HP_PET_DEFICIT:Hide() 
				else
					HP_PET_DEFICIT:Show()
					if (Options.defFormat==0) then
						HP_PET_DEFICIT:SetText("-" ..deficit)
					elseif (Options.defFormat==1) then		
						HP_PET_DEFICIT:SetText(string.format("-%.1f", (deficit/1000)))
					end
				end
			end
			this.TimeSinceLastUpdate=0
		end
	else
		HP_PET_FRAME:Hide()
	end
end
---------------------------------------------------------
function MP_Pet(arg1)
	if (Options.showPet==1) then
		this.TimeSinceLastUpdate=this.TimeSinceLastUpdate + arg1
		if (this.TimeSinceLastUpdate > Options.update) then	
			if (UnitExists("pet")) then	
			local cur, max = UnitMana("pet"), UnitManaMax("pet")
			local deficit = max-cur	
			--mp pet bar
				if (cur==0) then
					MP_PET_BAR:SetHeight(1)
				else
					MP_PET_BAR:SetHeight((Options.bgHeight/2)/max*cur)
					MP_Pet_Color()
				end
			--mp pet max text
				MP_PET_MAX:SetText(UnitManaMax("pet"))
				if (UnitPowerType("pet")==0) then
					MP_PET_MAX:SetTextColor(0, 0, 1, 1)
				elseif (UnitPowerType("pet")==1) then
					MP_PET_MAX:SetTextColor(1, 0, 0, 1)
				elseif (UnitPowerType("pet")==2) then
					MP_PET_MAX:SetTextColor(1, 1, 0, 1)
				elseif (UnitPowerType("pet")==3) then
					MP_PET_MAX:SetTextColor(1, 1, 0, 1)
				end
			--mp pet current text
				MP_PET_CURRENT:SetText(cur)
			--mp pet percent text
				MP_PET_PERCENT:SetText(string.format("%.0f", (100/max*cur)) .."%")
			--mp pet deficit text
				if (cur/max)>0.9
				or (cur/max)<0.1 then 
					MP_PET_DEFICIT:Hide()
				else
					if (UnitPowerType("pet")==0) then
						MP_PET_DEFICIT:Show()
						if (Options.defFormat==0) then
							MP_PET_DEFICIT:SetText("-" ..deficit)
						elseif (Options.defFormat==1) then		
							MP_PET_DEFICIT:SetText(string.format("-%.1f", (deficit/1000)))
						end
					elseif (UnitPowerType("pet")==1)
						or (UnitPowerType("pet")==2)
						or (UnitPowerType("pet")==3) then
							MP_PET_DEFICIT:Show()
							MP_PET_DEFICIT:SetText(cur)
					end
				end
			end
			this.TimeSinceLastUpdate=0
		end
	else
		MP_PET_FRAME:Hide()
	end
end
---------------------------------------------------------
function HP_TargetTarget(arg1)
	if (Options.showTT==1) then
		this.TimeSinceLastUpdate=this.TimeSinceLastUpdate + arg1
		if (this.TimeSinceLastUpdate > Options.update) then
			if (UnitExists("targettarget")) then
			--MobHealth
				local cur, max, found
				local deficit
				if MobHealth3 then
					cur, max, found = MobHealth3:GetUnitHealth("targettarget", UnitHealth("targettarget"), UnitHealthMax("targettarget"))
					deficit = max-cur
				else
					cur, max = UnitHealth("target"), UnitHealthMax("target")
					deficit = max-cur
				end
			--hp targettarget bar
				if (cur==0) then
					HP_TARGETTARGET_BAR:SetHeight(1)
				else
					HP_TARGETTARGET_BAR:SetHeight((Options.bgHeight/2)/max*cur)
					HP_TargetTarget_Color()
				end
			--hp targettarget max text
				HP_TARGETTARGET_MAX:SetText(max)
			--hp targettarget current text
				HP_TARGETTARGET_CURRENT:SetText(cur)
			--hp targettarget percent text
				HP_TARGETTARGET_PERCENT:SetText(string.format("%.0f", (100/max*cur)) .."%")
			--hp targettarget deficit text
				if (cur/max)>0.9
				or (cur/max)<0.1 then
					HP_TARGETTARGET_DEFICIT:Hide() 
				else
					HP_TARGETTARGET_DEFICIT:Show()
					if (Options.defFormat==0) then
						HP_TARGETTARGET_DEFICIT:SetText("-" ..deficit)
					elseif (Options.defFormat==1) then		
						HP_TARGETTARGET_DEFICIT:SetText(string.format("-%.1f", (deficit/1000)))
					end
				end
			end
			this.TimeSinceLastUpdate=0
		end
	else
		HP_TARGETTARGET_FRAME:Hide()
	end
end
---------------------------------------------------------
function MP_TargetTarget(arg1)
	if (Options.showTT==1) then
		this.TimeSinceLastUpdate=this.TimeSinceLastUpdate + arg1
		if (this.TimeSinceLastUpdate > Options.update) then	
			if (UnitExists("targettarget")) then
			local cur, max = UnitMana("targettarget"), UnitManaMax("targettarget")
			local deficit = max-cur	
			--mp targettarget bar
				if (cur==0) then
					MP_TARGETTARGET_BAR:SetHeight(1)
				else
					MP_TARGETTARGET_BAR:SetHeight((Options.bgHeight/2)/max*cur)
					MP_TargetTarget_Color()
				end
			--mp targettarget max text
				MP_TARGETTARGET_MAX:SetText(UnitManaMax("targettarget"))
				if (UnitPowerType("targettarget")==0) then
					MP_TARGETTARGET_MAX:SetTextColor(0, 0, 1, 1)
				elseif (UnitPowerType("targettarget")==1) then
					MP_TARGETTARGET_MAX:SetTextColor(1, 0, 0, 1)
				elseif (UnitPowerType("targettarget")==2) then
					MP_TARGETTARGET_MAX:SetTextColor(1, 1, 0, 1)
				elseif (UnitPowerType("targettarget")==3) then
					MP_TARGETTARGET_MAX:SetTextColor(1, 1, 0, 1)
				end
			--mp targettarget current text
				MP_TARGETTARGET_CURRENT:SetText(cur)
			--mp targettarget percent text
				MP_TARGETTARGET_PERCENT:SetText(string.format("%.0f", (100/max*cur)) .."%")
			--mp targettarget deficit text
				if (cur/max)>0.9
				or (cur/max)<0.1 then 
					MP_TARGETTARGET_DEFICIT:Hide()
				else
					if (UnitPowerType("targettarget")==0) then
						MP_TARGETTARGET_DEFICIT:Show()
						if (Options.defFormat==0) then
							MP_TARGETTARGET_DEFICIT:SetText("-" ..deficit)
						elseif (Options.defFormat==1) then		
							MP_TARGETTARGET_DEFICIT:SetText(string.format("-%.1f", (deficit/1000)))
						end
					elseif (UnitPowerType("targettarget")==1)
						or (UnitPowerType("targettarget")==2)
						or (UnitPowerType("targettarget")==3) then
							MP_TARGETTARGET_DEFICIT:Show()
							MP_TARGETTARGET_DEFICIT:SetText(cur)
					end
				end
			end
			this.TimeSinceLastUpdate=0
		end
	else
		MP_TARGETTARGET_FRAME:Hide()
	end
end
---------------------------------------------------------
function HP_Player_Color()
	local playerHPDeficit =  (1-(UnitHealth("player")/UnitHealthMax("player")))
	-- grey frame for those conditions
	if (UnitIsGhost("player")) 
	or (UnitIsDead("player")) then
		HP_PLAYER_BAR_TEXTURE:SetVertexColor(0.5, 0.5, 0.5, Colors.hp100.a)
		HP_PLAYER_BG_TEXTURE1:SetVertexColor(0.5, 0.5, 0.5, Colors.hp100.a)
		HP_PLAYER_CURRENT:SetTextColor(0.5, 0.5, 0.5, Colors.hp100.a)
		HP_PLAYER_PERCENT:SetTextColor(0.5, 0.5, 0.5, Colors.hp100.a)
		HP_PLAYER_DEFICIT:SetTextColor(0.5, 0.5, 0.5, Colors.hp100.a)
	else
	--100
	if (playerHPDeficit == 0) then 
		HP_PLAYER_BAR_TEXTURE:SetVertexColor(Colors.hp100.r, Colors.hp100.g, Colors.hp100.b, Colors.hp100.a)
		HP_PLAYER_BG_TEXTURE1:SetVertexColor(Colors.hp100.r, Colors.hp100.g, Colors.hp100.b, Colors.hp100.a)
		HP_PLAYER_CURRENT:SetTextColor(Colors.hp100.r, Colors.hp100.g, Colors.hp100.b, Colors.hp100.a)
		HP_PLAYER_PERCENT:SetTextColor(Colors.hp100.r, Colors.hp100.g, Colors.hp100.b, Colors.hp100.a)
		HP_PLAYER_DEFICIT:SetTextColor(Colors.hp100.r, Colors.hp100.g, Colors.hp100.b, Colors.hp100.a)
	--  > 0 < 0.5
	elseif (playerHPDeficit > 0) and (playerHPDeficit < 0.5) then 
		HP_PLAYER_BAR_TEXTURE:SetVertexColor(playerHPDeficit*2, Colors.hp100.g, Colors.hp100.b, Colors.hp100.a)
		HP_PLAYER_BG_TEXTURE1:SetVertexColor(playerHPDeficit*2, Colors.hp100.g, Colors.hp100.b, Colors.hp100.a)
		HP_PLAYER_CURRENT:SetTextColor(playerHPDeficit*2, Colors.hp100.g, Colors.hp100.b, Colors.hp100.a)
		HP_PLAYER_PERCENT:SetTextColor(playerHPDeficit*2, Colors.hp100.g, Colors.hp100.b, Colors.hp100.a)
		HP_PLAYER_DEFICIT:SetTextColor(playerHPDeficit*2, Colors.hp100.g, Colors.hp100.b, Colors.hp100.a)
	-- >0.5 < 0.8
	elseif (playerHPDeficit > 0.5) and (playerHPDeficit < 0.8) then
		HP_PLAYER_BAR_TEXTURE:SetVertexColor(Colors.hp50.r, (1-playerHPDeficit)*2, Colors.hp50.b, Colors.hp50.a)
		HP_PLAYER_BG_TEXTURE1:SetVertexColor(Colors.hp50.r, (1-playerHPDeficit)*2, Colors.hp50.b, Colors.hp50.a)
		HP_PLAYER_CURRENT:SetTextColor(Colors.hp50.r, (1-playerHPDeficit)*2, Colors.hp50.b, Colors.hp50.a)
		HP_PLAYER_PERCENT:SetTextColor(Colors.hp50.r, (1-playerHPDeficit)*2, Colors.hp50.b, Colors.hp50.a)
		HP_PLAYER_DEFICIT:SetTextColor(Colors.hp50.r, (1-playerHPDeficit)*2, Colors.hp50.b, Colors.hp50.a)
	-- 20-
	elseif (playerHPDeficit == 0.8) or (playerHPDeficit > 0.8) then 
		HP_PLAYER_BAR_TEXTURE:SetVertexColor(Colors.hp20.r, Colors.hp20.g, Colors.hp20.b, Colors.hp20.a)
		HP_PLAYER_BG_TEXTURE1:SetVertexColor(Colors.hp20.r, Colors.hp20.g, Colors.hp20.b, Colors.hp20.a)
		HP_PLAYER_CURRENT:SetTextColor(Colors.hp20.r, Colors.hp20.g, Colors.hp20.b, Colors.hp20.a)
		HP_PLAYER_PERCENT:SetTextColor(Colors.hp20.r, Colors.hp20.g, Colors.hp20.b, Colors.hp20.a)
		HP_PLAYER_DEFICIT:SetTextColor(Colors.hp20.r, Colors.hp20.g, Colors.hp20.b, Colors.hp20.a)
		--startflashing
		--UIFrameFlash(HP_PLAYER_BAR_TEXTURE, 1, 1, 1, true, 0, 0)
		--UIFrameFlash(HP_PLAYER_BG_TEXTURE1, 1, 1, 1, true, 0, 0)
	end
	end
end
---------------------------------------------------------
function MP_Player_Color()
	local playerMPDeficit =  (1-(UnitMana("player")/UnitManaMax("player")))
	--powertype mana
	if (UnitPowerType("player")==0) then 
		--100
		if (playerMPDeficit == 0) then 
			MP_PLAYER_BAR_TEXTURE:SetVertexColor(Colors.mp100.r, Colors.mp100.g, Colors.mp100.b, Colors.mp100.a)
			MP_PLAYER_BG_TEXTURE1:SetVertexColor(Colors.mp100.r, Colors.mp100.g, Colors.mp100.b, Colors.mp100.a)
			MP_PLAYER_CURRENT:SetTextColor(Colors.mp100.r, Colors.mp100.g, Colors.mp100.b, Colors.mp100.a)
			MP_PLAYER_PERCENT:SetTextColor(Colors.mp100.r, Colors.mp100.g, Colors.mp100.b, Colors.mp100.a)
			MP_PLAYER_DEFICIT:SetTextColor(Colors.mp100.r, Colors.mp100.g, Colors.mp100.b, Colors.mp100.a)
		--  > 0 < 0.5
		elseif (playerMPDeficit > 0) and (playerMPDeficit < 0.5) then 
			MP_PLAYER_BAR_TEXTURE:SetVertexColor(playerMPDeficit*2, playerMPDeficit*2, Colors.mp100.b, Colors.mp100.a)
			MP_PLAYER_BG_TEXTURE1:SetVertexColor(playerMPDeficit*2, playerMPDeficit*2, Colors.mp100.b, Colors.mp100.a)
			MP_PLAYER_CURRENT:SetTextColor(playerMPDeficit*2, playerMPDeficit*2, Colors.mp100.b, Colors.mp100.a)
			MP_PLAYER_PERCENT:SetTextColor(playerMPDeficit*2, playerMPDeficit*2, Colors.mp100.b, Colors.mp100.a)
			MP_PLAYER_DEFICIT:SetTextColor(playerMPDeficit*2, playerMPDeficit*2, Colors.mp100.b, Colors.mp100.a)
		-- >0.5 < 0.8
		elseif (playerMPDeficit > 0.5) and (playerMPDeficit < 0.8) then
			MP_PLAYER_BAR_TEXTURE:SetVertexColor(Colors.mp50.r, (1-playerMPDeficit)*2, (1-playerMPDeficit)*2, Colors.mp50.a)
			MP_PLAYER_BG_TEXTURE1:SetVertexColor(Colors.mp50.r, (1-playerMPDeficit)*2, (1-playerMPDeficit)*2, Colors.mp50.a)
			MP_PLAYER_CURRENT:SetTextColor(Colors.mp50.r, (1-playerMPDeficit)*2, (1-playerMPDeficit)*2, Colors.mp50.a)
			MP_PLAYER_PERCENT:SetTextColor(Colors.mp50.r, (1-playerMPDeficit)*2, (1-playerMPDeficit)*2, Colors.mp50.a)
			MP_PLAYER_DEFICIT:SetTextColor(Colors.mp50.r, (1-playerMPDeficit)*2, (1-playerMPDeficit)*2, Colors.mp50.a)
		-- 20-
		elseif (playerMPDeficit == 0.8) or (playerMPDeficit > 0.8) then
			MP_PLAYER_BAR_TEXTURE:SetVertexColor(Colors.mp20.r, Colors.mp20.g, Colors.mp20.b, Colors.mp20.a)
			MP_PLAYER_BG_TEXTURE1:SetVertexColor(Colors.mp20.r, Colors.mp20.g, Colors.mp20.b, Colors.mp20.a)
			MP_PLAYER_CURRENT:SetTextColor(Colors.mp20.r, Colors.mp20.g, Colors.mp20.b, Colors.mp20.a)
			MP_PLAYER_PERCENT:SetTextColor(Colors.mp20.r, Colors.mp20.g, Colors.mp20.b, Colors.mp20.a)
			MP_PLAYER_DEFICIT:SetTextColor(Colors.mp20.r, Colors.mp20.g, Colors.mp20.b, Colors.mp20.a)
		--startflashing
			--UIFrameFlash(MP_PLAYER_BAR_TEXTURE, 1, 1, 1, true, 0, 0)
			--UIFrameFlash(MP_PLAYER_BG_TEXTURE1, 1, 1, 1, true, 0, 0)	
		end
	--powertype rage
	elseif (UnitPowerType("player")==1) then 
		MP_PLAYER_BAR_TEXTURE:SetVertexColor(1, 0, 0, Colors.mp100.a)
		MP_PLAYER_BG_TEXTURE1:SetVertexColor(1, 0, 0, Colors.mp100.a)
		MP_PLAYER_CURRENT:SetTextColor(1, 0, 0, Colors.mp100.a)
		MP_PLAYER_PERCENT:SetTextColor(1, 0, 0, Colors.mp100.a)
		MP_PLAYER_DEFICIT:SetTextColor(1, 0, 0, Colors.mp100.a)
	--powertype focus/energy
	elseif (UnitPowerType("player")==2) or (UnitPowerType("player")==3) then 
		MP_PLAYER_BAR_TEXTURE:SetVertexColor(1, 1, 0, Colors.mp100.a)
		MP_PLAYER_BG_TEXTURE1:SetVertexColor(1, 1, 0,Colors.mp100.a)
		MP_PLAYER_CURRENT:SetTextColor(1, 1, 0, Colors.mp100.a)
		MP_PLAYER_PERCENT:SetTextColor(1, 1, 0, Colors.mp100.a)
		MP_PLAYER_DEFICIT:SetTextColor(1, 1, 0, Colors.mp100.a)
	end
end
---------------------------------------------------------
function HP_Target_Color()
	local targetHPDeficit =  (1-(UnitHealth("target")/UnitHealthMax("target")))
	-- grey frame for those conditions
	if (UnitIsTapped("target")) and (not UnitIsTappedByPlayer("target"))
	or (UnitIsTrivial("target"))
	or (UnitIsGhost("target")) 
	or (UnitIsDead("target"))
	or (not UnitIsConnected("target")) then
		HP_TARGET_BAR_TEXTURE:SetVertexColor(0.5, 0.5, 0.5, Colors.hp100.a)
		HP_TARGET_BG_TEXTURE1:SetVertexColor(0.5, 0.5, 0.5, Colors.hp100.a)
		HP_TARGET_CURRENT:SetTextColor(0.5, 0.5, 0.5, Colors.hp100.a)
		HP_TARGET_PERCENT:SetTextColor(0.5, 0.5, 0.5, Colors.hp100.a)
		HP_TARGET_DEFICIT:SetTextColor(0.5, 0.5, 0.5, Colors.hp100.a)
	else
		--100
		if (targetHPDeficit == 0) then 
			HP_TARGET_BAR_TEXTURE:SetVertexColor(Colors.hp100.r, Colors.hp100.g, Colors.hp100.b, Colors.hp100.a)
			HP_TARGET_BG_TEXTURE1:SetVertexColor(Colors.hp100.r, Colors.hp100.g, Colors.hp100.b, Colors.hp100.a)
			HP_TARGET_CURRENT:SetTextColor(Colors.hp100.r, Colors.hp100.g, Colors.hp100.b, Colors.hp100.a)
			HP_TARGET_PERCENT:SetTextColor(Colors.hp100.r, Colors.hp100.g, Colors.hp100.b, Colors.hp100.a)
			HP_TARGET_DEFICIT:SetTextColor(Colors.hp100.r, Colors.hp100.g, Colors.hp100.b, Colors.hp100.a)
		--  > 0 < 0.5
		elseif (targetHPDeficit > 0) and (targetHPDeficit < 0.5) then 
			HP_TARGET_BAR_TEXTURE:SetVertexColor(targetHPDeficit*2, Colors.hp100.g, Colors.hp100.b, Colors.hp100.a)
			HP_TARGET_BG_TEXTURE1:SetVertexColor(targetHPDeficit*2, Colors.hp100.g, Colors.hp100.b, Colors.hp100.a)
			HP_TARGET_CURRENT:SetTextColor(targetHPDeficit*2, Colors.hp100.g, Colors.hp100.b, Colors.hp100.a)
			HP_TARGET_PERCENT:SetTextColor(targetHPDeficit*2, Colors.hp100.g, Colors.hp100.b, Colors.hp100.a)
			HP_TARGET_DEFICIT:SetTextColor(targetHPDeficit*2, Colors.hp100.g, Colors.hp100.b, Colors.hp100.a)
		-- >0.5 < 0.8
		elseif (targetHPDeficit > 0.5) and (targetHPDeficit < 0.8) then
			HP_TARGET_BAR_TEXTURE:SetVertexColor(Colors.hp50.r, (1-targetHPDeficit)*2, Colors.hp50.b, Colors.hp50.a)
			HP_TARGET_BG_TEXTURE1:SetVertexColor(Colors.hp50.r, (1-targetHPDeficit)*2, Colors.hp50.b, Colors.hp50.a)
			HP_TARGET_CURRENT:SetTextColor(Colors.hp50.r, (1-targetHPDeficit)*2, Colors.hp50.b, Colors.hp50.a)
			HP_TARGET_PERCENT:SetTextColor(Colors.hp50.r, (1-targetHPDeficit)*2, Colors.hp50.b, Colors.hp50.a)
			HP_TARGET_DEFICIT:SetTextColor(Colors.hp50.r, (1-targetHPDeficit)*2, Colors.hp50.b, Colors.hp50.a)
		-- 20-
		elseif (targetHPDeficit == 0.8) or (targetHPDeficit > 0.8) then 
			HP_TARGET_BAR_TEXTURE:SetVertexColor(Colors.hp20.r, Colors.hp20.g, Colors.hp20.b, Colors.hp20.a)
			HP_TARGET_BG_TEXTURE1:SetVertexColor(Colors.hp20.r, Colors.hp20.g, Colors.hp20.b, Colors.hp20.a)
			HP_TARGET_CURRENT:SetTextColor(Colors.hp20.r, Colors.hp20.g, Colors.hp20.b, Colors.hp20.a)
			HP_TARGET_PERCENT:SetTextColor(Colors.hp20.r, Colors.hp20.g, Colors.hp20.b, Colors.hp20.a)
			HP_TARGET_DEFICIT:SetTextColor(Colors.hp20.r, Colors.hp20.g, Colors.hp20.b, Colors.hp20.a)
		--startflashing
			--UIFrameFlash(HP_TARGET_BAR_TEXTURE, 1, 1, 1, true, 0, 0)
			--UIFrameFlash(HP_TARGET_BG_TEXTURE1, 1, 1, 1, true, 0, 0)
		end
	end
end
---------------------------------------------------------
function MP_Target_Color()
	local targetMPDeficit =  (1-(UnitMana("target")/UnitManaMax("target")))
	
	--powertype mana
	if (UnitPowerType("target")==0) then 
		--100
		if (targetMPDeficit == 0) then 
			MP_TARGET_BAR_TEXTURE:SetVertexColor(Colors.mp100.r, Colors.mp100.g, Colors.mp100.b, Colors.mp100.a)
			MP_TARGET_BG_TEXTURE1:SetVertexColor(Colors.mp100.r, Colors.mp100.g, Colors.mp100.b, Colors.mp100.a)
			MP_TARGET_CURRENT:SetTextColor(Colors.mp100.r, Colors.mp100.g, Colors.mp100.b, Colors.mp100.a)
			MP_TARGET_PERCENT:SetTextColor(Colors.mp100.r, Colors.mp100.g, Colors.mp100.b, Colors.mp100.a)
			MP_TARGET_DEFICIT:SetTextColor(Colors.mp100.r, Colors.mp100.g, Colors.mp100.b, Colors.mp100.a)
		--  > 0 < 0.5
		elseif (targetMPDeficit > 0) and (targetMPDeficit < 0.5) then 
			MP_TARGET_BAR_TEXTURE:SetVertexColor(targetMPDeficit*2, targetMPDeficit*2, Colors.mp100.b, Colors.mp100.a)
			MP_TARGET_BG_TEXTURE1:SetVertexColor(targetMPDeficit*2, targetMPDeficit*2, Colors.mp100.b, Colors.mp100.a)
			MP_TARGET_CURRENT:SetTextColor(targetMPDeficit*2, targetMPDeficit*2, Colors.mp100.b, Colors.mp100.a)
			MP_TARGET_PERCENT:SetTextColor(targetMPDeficit*2, targetMPDeficit*2, Colors.mp100.b, Colors.mp100.a)
			MP_TARGET_DEFICIT:SetTextColor(targetMPDeficit*2, targetMPDeficit*2, Colors.mp100.b, Colors.mp100.a)
		-- >0.5 < 0.8
		elseif (targetMPDeficit > 0.5) and (targetMPDeficit < 0.8) then
			MP_TARGET_BAR_TEXTURE:SetVertexColor(Colors.mp50.r, (1-targetMPDeficit)*2, (1-targetMPDeficit)*2, Colors.mp50.a)
			MP_TARGET_BG_TEXTURE1:SetVertexColor(Colors.mp50.r, (1-targetMPDeficit)*2, (1-targetMPDeficit)*2, Colors.mp50.a)
			MP_TARGET_CURRENT:SetTextColor(Colors.mp50.r, (1-targetMPDeficit)*2, (1-targetMPDeficit)*2, Colors.mp50.a)
			MP_TARGET_PERCENT:SetTextColor(Colors.mp50.r, (1-targetMPDeficit)*2, (1-targetMPDeficit)*2, Colors.mp50.a)
			MP_TARGET_DEFICIT:SetTextColor(Colors.mp50.r, (1-targetMPDeficit)*2, (1-targetMPDeficit)*2, Colors.mp50.a)
		-- 20-
		elseif (targetMPDeficit == 0.8) or (targetMPDeficit > 0.8) then
			MP_TARGET_BAR_TEXTURE:SetVertexColor(Colors.mp20.r, Colors.mp20.g, Colors.mp20.b, Colors.mp20.a)
			MP_TARGET_BG_TEXTURE1:SetVertexColor(Colors.mp20.r, Colors.mp20.g, Colors.mp20.b, Colors.mp20.a)
			MP_TARGET_CURRENT:SetTextColor(Colors.mp20.r, Colors.mp20.g, Colors.mp20.b, Colors.mp20.a)
			MP_TARGET_PERCENT:SetTextColor(Colors.mp20.r, Colors.mp20.g, Colors.mp20.b, Colors.mp20.a)
			MP_TARGET_DEFICIT:SetTextColor(Colors.mp20.r, Colors.mp20.g, Colors.mp20.b, Colors.mp20.a)
		--startflashing
			--UIFrameFlash(MP_TARGET_BAR_TEXTURE, 1, 1, 1, true, 0, 0)
			--UIFrameFlash(MP_TARGET_BG_TEXTURE1, 1, 1, 1, true, 0, 0)	
		end
	--powertype rage
	elseif (UnitPowerType("target")==1) then 
		MP_TARGET_BAR_TEXTURE:SetVertexColor(1, 0, 0, Colors.mp100.a)
		MP_TARGET_BG_TEXTURE1:SetVertexColor(1, 0, 0, Colors.mp100.a)
		MP_TARGET_CURRENT:SetTextColor(1, 0, 0, Colors.mp100.a)
		MP_TARGET_PERCENT:SetTextColor(1, 0, 0, Colors.mp100.a)
		MP_TARGET_DEFICIT:SetTextColor(1, 0, 0, Colors.mp100.a)
	--powertype focus/energy
	elseif (UnitPowerType("target")==2) or (UnitPowerType("target")==3) then 
		MP_TARGET_BAR_TEXTURE:SetVertexColor(1, 1, 0, Colors.mp100.a)
		MP_TARGET_BG_TEXTURE1:SetVertexColor(1, 1, 0,Colors.mp100.a)
		MP_TARGET_CURRENT:SetTextColor(1, 1, 0, Colors.mp100.a)
		MP_TARGET_PERCENT:SetTextColor(1, 1, 0, Colors.mp100.a)
		MP_TARGET_DEFICIT:SetTextColor(1, 1, 0, Colors.mp100.a)
	end
end
---------------------------------------------------------
function HP_Party1_Color()
	local party1HPDeficit =  (1-(UnitHealth("party1")/UnitHealthMax("party1")))
	-- grey frame for those conditions
	if (UnitIsGhost("party1")) 
	or (UnitIsDead("party1"))
	or (not UnitIsConnected("party1")) then
		HP_PARTY1_BAR_TEXTURE:SetVertexColor(0.5, 0.5, 0.5, Colors.hp100.a)
		HP_PARTY1_BG_TEXTURE1:SetVertexColor(0.5, 0.5, 0.5, Colors.hp100.a)
		HP_PARTY1_DEFICIT:SetTextColor(0.5, 0.5, 0.5, Colors.hp100.a)
	else
	--100
	if (party1HPDeficit == 0) then 
		HP_PARTY1_BAR_TEXTURE:SetVertexColor(Colors.hp100.r, Colors.hp100.g, Colors.hp100.b, Colors.hp100.a)
		HP_PARTY1_BG_TEXTURE1:SetVertexColor(Colors.hp100.r, Colors.hp100.g, Colors.hp100.b, Colors.hp100.a)
		HP_PARTY1_DEFICIT:SetTextColor(Colors.hp100.r, Colors.hp100.g, Colors.hp100.b, Colors.hp100.a)
	--  > 0 < 0.5
	elseif (party1HPDeficit > 0) and (party1HPDeficit < 0.5) then 
		HP_PARTY1_BAR_TEXTURE:SetVertexColor(party1HPDeficit*2, Colors.hp100.g, Colors.hp100.b, Colors.hp100.a)
		HP_PARTY1_BG_TEXTURE1:SetVertexColor(party1HPDeficit*2, Colors.hp100.g, Colors.hp100.b, Colors.hp100.a)
		HP_PARTY1_DEFICIT:SetTextColor(party1HPDeficit*2, Colors.hp100.g, Colors.hp100.b, Colors.hp100.a)
	-- >0.5 < 0.8
	elseif (party1HPDeficit > 0.5) and (party1HPDeficit < 0.8) then
		HP_PARTY1_BAR_TEXTURE:SetVertexColor(Colors.hp50.r, (1-party1HPDeficit)*2, Colors.hp50.b, Colors.hp50.a)
		HP_PARTY1_BG_TEXTURE1:SetVertexColor(Colors.hp50.r, (1-party1HPDeficit)*2, Colors.hp50.b, Colors.hp50.a)
		HP_PARTY1_DEFICIT:SetTextColor(Colors.hp50.r, (1-party1HPDeficit)*2, Colors.hp50.b, Colors.hp50.a)
	-- 20-
	elseif (party1HPDeficit == 0.8) or (party1HPDeficit > 0.8) then 
		HP_PARTY1_BAR_TEXTURE:SetVertexColor(Colors.hp20.r, Colors.hp20.g, Colors.hp20.b, Colors.hp20.a)
		HP_PARTY1_BG_TEXTURE1:SetVertexColor(Colors.hp20.r, Colors.hp20.g, Colors.hp20.b, Colors.hp20.a)
		HP_PARTY1_DEFICIT:SetTextColor(Colors.hp20.r, Colors.hp20.g, Colors.hp20.b, Colors.hp20.a)
		--startflashing
		--UIFrameFlash(HP_PARTY1_BAR_TEXTURE, 1, 1, 1, true, 0, 0)
		--UIFrameFlash(HP_PARTY1_BG_TEXTURE1, 1, 1, 1, true, 0, 0)
	end
	end
end
---------------------------------------------------------
function MP_Party1_Color()
	local party1MPDeficit =  (1-(UnitMana("party1")/UnitManaMax("party1")))
	--powertype mana
	if (UnitPowerType("party1")==0) then 
		--100
		if (party1MPDeficit == 0) then 
			MP_PARTY1_BAR_TEXTURE:SetVertexColor(Colors.mp100.r, Colors.mp100.g, Colors.mp100.b, Colors.mp100.a)
			MP_PARTY1_BG_TEXTURE1:SetVertexColor(Colors.mp100.r, Colors.mp100.g, Colors.mp100.b, Colors.mp100.a)
			MP_PARTY1_DEFICIT:SetTextColor(Colors.mp100.r, Colors.mp100.g, Colors.mp100.b, Colors.mp100.a)
		--  > 0 < 0.5
		elseif (party1MPDeficit > 0) and (party1MPDeficit < 0.5) then 
			MP_PARTY1_BAR_TEXTURE:SetVertexColor(party1MPDeficit*2, party1MPDeficit*2, Colors.mp100.b, Colors.mp100.a)
			MP_PARTY1_BG_TEXTURE1:SetVertexColor(party1MPDeficit*2, party1MPDeficit*2, Colors.mp100.b, Colors.mp100.a)
			MP_PARTY1_DEFICIT:SetTextColor(party1MPDeficit*2, party1MPDeficit*2, Colors.mp100.b, Colors.mp100.a)
		-- >0.5 < 0.8
		elseif (party1MPDeficit > 0.5) and (party1MPDeficit < 0.8) then
			MP_PARTY1_BAR_TEXTURE:SetVertexColor(Colors.mp50.r, (1-party1MPDeficit)*2, (1-party1MPDeficit)*2, Colors.mp50.a)
			MP_PARTY1_BG_TEXTURE1:SetVertexColor(Colors.mp50.r, (1-party1MPDeficit)*2, (1-party1MPDeficit)*2, Colors.mp50.a)
			MP_PARTY1_DEFICIT:SetTextColor(Colors.mp50.r, (1-party1MPDeficit)*2, (1-party1MPDeficit)*2, Colors.mp50.a)
		-- 20-
		elseif (party1MPDeficit == 0.8) or (party1MPDeficit > 0.8) then
			MP_PARTY1_BAR_TEXTURE:SetVertexColor(Colors.mp20.r, Colors.mp20.g, Colors.mp20.b, Colors.mp20.a)
			MP_PARTY1_BG_TEXTURE1:SetVertexColor(Colors.mp20.r, Colors.mp20.g, Colors.mp20.b, Colors.mp20.a)
			MP_PARTY1_DEFICIT:SetTextColor(Colors.mp20.r, Colors.mp20.g, Colors.mp20.b, Colors.mp20.a)
		--startflashing
			--UIFrameFlash(MP_PARTY1_BAR_TEXTURE, 1, 1, 1, true, 0, 0)
			--UIFrameFlash(MP_PARTY1_BG_TEXTURE1, 1, 1, 1, true, 0, 0)	
		end
	--powertype rage
	elseif (UnitPowerType("party1")==1) then 
		MP_PARTY1_BAR_TEXTURE:SetVertexColor(1, 0, 0, Colors.mp100.a)
		MP_PARTY1_BG_TEXTURE1:SetVertexColor(1, 0, 0, Colors.mp100.a)
		MP_PARTY1_DEFICIT:SetTextColor(1, 0, 0, Colors.mp100.a)
	--powertype focus/energy
	elseif (UnitPowerType("party1")==2) or (UnitPowerType("party1")==3) then 
		MP_PARTY1_BAR_TEXTURE:SetVertexColor(1, 1, 0, Colors.mp100.a)
		MP_PARTY1_BG_TEXTURE1:SetVertexColor(1, 1, 0,Colors.mp100.a)
		MP_PARTY1_DEFICIT:SetTextColor(1, 1, 0, Colors.mp100.a)
	end
end
---------------------------------------------------------
function HP_Party2_Color()
	local party2HPDeficit =  (1-(UnitHealth("party2")/UnitHealthMax("party2")))
	-- grey frame for those conditions
	if (UnitIsGhost("party2")) 
	or (UnitIsDead("party2"))
	or (not UnitIsConnected("party2")) then
		HP_PARTY2_BAR_TEXTURE:SetVertexColor(0.5, 0.5, 0.5, Colors.hp100.a)
		HP_PARTY2_BG_TEXTURE1:SetVertexColor(0.5, 0.5, 0.5, Colors.hp100.a)
		HP_PARTY2_DEFICIT:SetTextColor(0.5, 0.5, 0.5, Colors.hp100.a)
	else
	--100
	if (party2HPDeficit == 0) then 
		HP_PARTY2_BAR_TEXTURE:SetVertexColor(Colors.hp100.r, Colors.hp100.g, Colors.hp100.b, Colors.hp100.a)
		HP_PARTY2_BG_TEXTURE1:SetVertexColor(Colors.hp100.r, Colors.hp100.g, Colors.hp100.b, Colors.hp100.a)
		HP_PARTY2_DEFICIT:SetTextColor(Colors.hp100.r, Colors.hp100.g, Colors.hp100.b, Colors.hp100.a)
	--  > 0 < 0.5
	elseif (party2HPDeficit > 0) and (party2HPDeficit < 0.5) then 
		HP_PARTY2_BAR_TEXTURE:SetVertexColor(party2HPDeficit*2, Colors.hp100.g, Colors.hp100.b, Colors.hp100.a)
		HP_PARTY2_BG_TEXTURE1:SetVertexColor(party2HPDeficit*2, Colors.hp100.g, Colors.hp100.b, Colors.hp100.a)
		HP_PARTY2_DEFICIT:SetTextColor(party2HPDeficit*2, Colors.hp100.g, Colors.hp100.b, Colors.hp100.a)
	-- >0.5 < 0.8
	elseif (party2HPDeficit > 0.5) and (party2HPDeficit < 0.8) then
		HP_PARTY2_BAR_TEXTURE:SetVertexColor(Colors.hp50.r, (1-party2HPDeficit)*2, Colors.hp50.b, Colors.hp50.a)
		HP_PARTY2_BG_TEXTURE1:SetVertexColor(Colors.hp50.r, (1-party2HPDeficit)*2, Colors.hp50.b, Colors.hp50.a)
		HP_PARTY2_DEFICIT:SetTextColor(Colors.hp50.r, (1-party2HPDeficit)*2, Colors.hp50.b, Colors.hp50.a)
	-- 20-
	elseif (party2HPDeficit == 0.8) or (party2HPDeficit > 0.8) then 
		HP_PARTY2_BAR_TEXTURE:SetVertexColor(Colors.hp20.r, Colors.hp20.g, Colors.hp20.b, Colors.hp20.a)
		HP_PARTY2_BG_TEXTURE1:SetVertexColor(Colors.hp20.r, Colors.hp20.g, Colors.hp20.b, Colors.hp20.a)
		HP_PARTY2_DEFICIT:SetTextColor(Colors.hp20.r, Colors.hp20.g, Colors.hp20.b, Colors.hp20.a)
		--startflashing
		--UIFrameFlash(HP_PARTY2_BAR_TEXTURE, 1, 1, 1, true, 0, 0)
		--UIFrameFlash(HP_PARTY2_BG_TEXTURE1, 1, 1, 1, true, 0, 0)
	end
	end
end
---------------------------------------------------------
function MP_Party2_Color()
	local party2MPDeficit =  (1-(UnitMana("party2")/UnitManaMax("party2")))
	--powertype mana
	if (UnitPowerType("party2")==0) then 
		--100
		if (party2MPDeficit == 0) then 
			MP_PARTY2_BAR_TEXTURE:SetVertexColor(Colors.mp100.r, Colors.mp100.g, Colors.mp100.b, Colors.mp100.a)
			MP_PARTY2_BG_TEXTURE1:SetVertexColor(Colors.mp100.r, Colors.mp100.g, Colors.mp100.b, Colors.mp100.a)
			MP_PARTY2_DEFICIT:SetTextColor(Colors.mp100.r, Colors.mp100.g, Colors.mp100.b, Colors.mp100.a)
		--  > 0 < 0.5
		elseif (party2MPDeficit > 0) and (party2MPDeficit < 0.5) then 
			MP_PARTY2_BAR_TEXTURE:SetVertexColor(party2MPDeficit*2, party2MPDeficit*2, Colors.mp100.b, Colors.mp100.a)
			MP_PARTY2_BG_TEXTURE1:SetVertexColor(party2MPDeficit*2, party2MPDeficit*2, Colors.mp100.b, Colors.mp100.a)
			MP_PARTY2_DEFICIT:SetTextColor(party2MPDeficit*2, party2MPDeficit*2, Colors.mp100.b, Colors.mp100.a)
		-- >0.5 < 0.8
		elseif (party2MPDeficit > 0.5) and (party2MPDeficit < 0.8) then
			MP_PARTY2_BAR_TEXTURE:SetVertexColor(Colors.mp50.r, (1-party2MPDeficit)*2, (1-party2MPDeficit)*2, Colors.mp50.a)
			MP_PARTY2_BG_TEXTURE1:SetVertexColor(Colors.mp50.r, (1-party2MPDeficit)*2, (1-party2MPDeficit)*2, Colors.mp50.a)
			MP_PARTY2_DEFICIT:SetTextColor(Colors.mp50.r, (1-party2MPDeficit)*2, (1-party2MPDeficit)*2, Colors.mp50.a)
		-- 20-
		elseif (party2MPDeficit == 0.8) or (party2MPDeficit > 0.8) then
			MP_PARTY2_BAR_TEXTURE:SetVertexColor(Colors.mp20.r, Colors.mp20.g, Colors.mp20.b, Colors.mp20.a)
			MP_PARTY2_BG_TEXTURE1:SetVertexColor(Colors.mp20.r, Colors.mp20.g, Colors.mp20.b, Colors.mp20.a)
			MP_PARTY2_DEFICIT:SetTextColor(Colors.mp20.r, Colors.mp20.g, Colors.mp20.b, Colors.mp20.a)
		--startflashing
			--UIFrameFlash(MP_PARTY2_BAR_TEXTURE, 1, 1, 1, true, 0, 0)
			--UIFrameFlash(MP_PARTY2_BG_TEXTURE1, 1, 1, 1, true, 0, 0)	
		end
	--powertype rage
	elseif (UnitPowerType("party2")==1) then 
		MP_PARTY2_BAR_TEXTURE:SetVertexColor(1, 0, 0, Colors.mp100.a)
		MP_PARTY2_BG_TEXTURE1:SetVertexColor(1, 0, 0, Colors.mp100.a)
		MP_PARTY2_DEFICIT:SetTextColor(1, 0, 0, Colors.mp100.a)
	--powertype focus/energy
	elseif (UnitPowerType("party2")==2) or (UnitPowerType("party2")==3) then 
		MP_PARTY2_BAR_TEXTURE:SetVertexColor(1, 1, 0, Colors.mp100.a)
		MP_PARTY2_BG_TEXTURE1:SetVertexColor(1, 1, 0,Colors.mp100.a)
		MP_PARTY2_DEFICIT:SetTextColor(1, 1, 0, Colors.mp100.a)
	end
end
---------------------------------------------------------
function HP_Party3_Color()
	local party3HPDeficit =  (1-(UnitHealth("party3")/UnitHealthMax("party3")))
	-- grey frame for those conditions
	if (UnitIsGhost("party3")) 
	or (UnitIsDead("party3"))
	or (not UnitIsConnected("party3")) then
		HP_PARTY3_BAR_TEXTURE:SetVertexColor(0.5, 0.5, 0.5, Colors.hp100.a)
		HP_PARTY3_BG_TEXTURE1:SetVertexColor(0.5, 0.5, 0.5, Colors.hp100.a)
		HP_PARTY3_DEFICIT:SetTextColor(0.5, 0.5, 0.5, Colors.hp100.a)
	else
	--100
	if (party3HPDeficit == 0) then 
		HP_PARTY3_BAR_TEXTURE:SetVertexColor(Colors.hp100.r, Colors.hp100.g, Colors.hp100.b, Colors.hp100.a)
		HP_PARTY3_BG_TEXTURE1:SetVertexColor(Colors.hp100.r, Colors.hp100.g, Colors.hp100.b, Colors.hp100.a)
		HP_PARTY3_DEFICIT:SetTextColor(Colors.hp100.r, Colors.hp100.g, Colors.hp100.b, Colors.hp100.a)
	--  > 0 < 0.5
	elseif (party3HPDeficit > 0) and (party3HPDeficit < 0.5) then 
		HP_PARTY3_BAR_TEXTURE:SetVertexColor(party3HPDeficit*2, Colors.hp100.g, Colors.hp100.b, Colors.hp100.a)
		HP_PARTY3_BG_TEXTURE1:SetVertexColor(party3HPDeficit*2, Colors.hp100.g, Colors.hp100.b, Colors.hp100.a)
		HP_PARTY3_DEFICIT:SetTextColor(party3HPDeficit*2, Colors.hp100.g, Colors.hp100.b, Colors.hp100.a)
	-- >0.5 < 0.8
	elseif (party3HPDeficit > 0.5) and (party3HPDeficit < 0.8) then
		HP_PARTY3_BAR_TEXTURE:SetVertexColor(Colors.hp50.r, (1-party3HPDeficit)*2, Colors.hp50.b, Colors.hp50.a)
		HP_PARTY3_BG_TEXTURE1:SetVertexColor(Colors.hp50.r, (1-party3HPDeficit)*2, Colors.hp50.b, Colors.hp50.a)
		HP_PARTY3_DEFICIT:SetTextColor(Colors.hp50.r, (1-party3HPDeficit)*2, Colors.hp50.b, Colors.hp50.a)
	-- 20-
	elseif (party3HPDeficit == 0.8) or (party3HPDeficit > 0.8) then 
		HP_PARTY3_BAR_TEXTURE:SetVertexColor(Colors.hp20.r, Colors.hp20.g, Colors.hp20.b, Colors.hp20.a)
		HP_PARTY3_BG_TEXTURE1:SetVertexColor(Colors.hp20.r, Colors.hp20.g, Colors.hp20.b, Colors.hp20.a)
		HP_PARTY3_DEFICIT:SetTextColor(Colors.hp20.r, Colors.hp20.g, Colors.hp20.b, Colors.hp20.a)
		--startflashing
		--UIFrameFlash(HP_PARTY3_BAR_TEXTURE, 1, 1, 1, true, 0, 0)
		--UIFrameFlash(HP_PARTY3_BG_TEXTURE1, 1, 1, 1, true, 0, 0)
	end
	end
end
---------------------------------------------------------
function MP_Party3_Color()
	local party3MPDeficit =  (1-(UnitMana("party3")/UnitManaMax("party3")))
	--powertype mana
	if (UnitPowerType("party3")==0) then 
		--100
		if (party3MPDeficit == 0) then 
			MP_PARTY3_BAR_TEXTURE:SetVertexColor(Colors.mp100.r, Colors.mp100.g, Colors.mp100.b, Colors.mp100.a)
			MP_PARTY3_BG_TEXTURE1:SetVertexColor(Colors.mp100.r, Colors.mp100.g, Colors.mp100.b, Colors.mp100.a)
			MP_PARTY3_DEFICIT:SetTextColor(Colors.mp100.r, Colors.mp100.g, Colors.mp100.b, Colors.mp100.a)
		--  > 0 < 0.5
		elseif (party3MPDeficit > 0) and (party3MPDeficit < 0.5) then 
			MP_PARTY3_BAR_TEXTURE:SetVertexColor(party3MPDeficit*2, party3MPDeficit*2, Colors.mp100.b, Colors.mp100.a)
			MP_PARTY3_BG_TEXTURE1:SetVertexColor(party3MPDeficit*2, party3MPDeficit*2, Colors.mp100.b, Colors.mp100.a)
			MP_PARTY3_DEFICIT:SetTextColor(party3MPDeficit*2, party3MPDeficit*2, Colors.mp100.b, Colors.mp100.a)
		-- >0.5 < 0.8
		elseif (party3MPDeficit > 0.5) and (party3MPDeficit < 0.8) then
			MP_PARTY3_BAR_TEXTURE:SetVertexColor(Colors.mp50.r, (1-party3MPDeficit)*2, (1-party3MPDeficit)*2, Colors.mp50.a)
			MP_PARTY3_BG_TEXTURE1:SetVertexColor(Colors.mp50.r, (1-party3MPDeficit)*2, (1-party3MPDeficit)*2, Colors.mp50.a)
			MP_PARTY3_DEFICIT:SetTextColor(Colors.mp50.r, (1-party3MPDeficit)*2, (1-party3MPDeficit)*2, Colors.mp50.a)
		-- 20-
		elseif (party3MPDeficit == 0.8) or (party3MPDeficit > 0.8) then
			MP_PARTY3_BAR_TEXTURE:SetVertexColor(Colors.mp20.r, Colors.mp20.g, Colors.mp20.b, Colors.mp20.a)
			MP_PARTY3_BG_TEXTURE1:SetVertexColor(Colors.mp20.r, Colors.mp20.g, Colors.mp20.b, Colors.mp20.a)
			MP_PARTY3_DEFICIT:SetTextColor(Colors.mp20.r, Colors.mp20.g, Colors.mp20.b, Colors.mp20.a)
		--startflashing
			--UIFrameFlash(MP_PARTY3_BAR_TEXTURE, 1, 1, 1, true, 0, 0)
			--UIFrameFlash(MP_PARTY3_BG_TEXTURE1, 1, 1, 1, true, 0, 0)	
		end
	--powertype rage
	elseif (UnitPowerType("party3")==1) then 
		MP_PARTY3_BAR_TEXTURE:SetVertexColor(1, 0, 0, Colors.mp100.a)
		MP_PARTY3_BG_TEXTURE1:SetVertexColor(1, 0, 0, Colors.mp100.a)
		MP_PARTY3_DEFICIT:SetTextColor(1, 0, 0, Colors.mp100.a)
	--powertype focus/energy
	elseif (UnitPowerType("party3")==2) or (UnitPowerType("party3")==3) then 
		MP_PARTY3_BAR_TEXTURE:SetVertexColor(1, 1, 0, Colors.mp100.a)
		MP_PARTY3_BG_TEXTURE1:SetVertexColor(1, 1, 0,Colors.mp100.a)
		MP_PARTY3_DEFICIT:SetTextColor(1, 1, 0, Colors.mp100.a)
	end
end
---------------------------------------------------------
function HP_Party4_Color()
	local party4HPDeficit =  (1-(UnitHealth("party4")/UnitHealthMax("party4")))
	-- grey frame for those conditions
	if (UnitIsGhost("party4")) 
	or (UnitIsDead("party4"))
	or (not UnitIsConnected("party4")) then
		HP_PARTY4_BAR_TEXTURE:SetVertexColor(0.5, 0.5, 0.5, Colors.hp100.a)
		HP_PARTY4_BG_TEXTURE1:SetVertexColor(0.5, 0.5, 0.5, Colors.hp100.a)
		HP_PARTY4_DEFICIT:SetTextColor(0.5, 0.5, 0.5, Colors.hp100.a)
	else
	--100
	if (party4HPDeficit == 0) then 
		HP_PARTY4_BAR_TEXTURE:SetVertexColor(Colors.hp100.r, Colors.hp100.g, Colors.hp100.b, Colors.hp100.a)
		HP_PARTY4_BG_TEXTURE1:SetVertexColor(Colors.hp100.r, Colors.hp100.g, Colors.hp100.b, Colors.hp100.a)
		HP_PARTY4_DEFICIT:SetTextColor(Colors.hp100.r, Colors.hp100.g, Colors.hp100.b, Colors.hp100.a)
	--  > 0 < 0.5
	elseif (party4HPDeficit > 0) and (party4HPDeficit < 0.5) then 
		HP_PARTY4_BAR_TEXTURE:SetVertexColor(party4HPDeficit*2, Colors.hp100.g, Colors.hp100.b, Colors.hp100.a)
		HP_PARTY4_BG_TEXTURE1:SetVertexColor(party4HPDeficit*2, Colors.hp100.g, Colors.hp100.b, Colors.hp100.a)
		HP_PARTY4_DEFICIT:SetTextColor(party4HPDeficit*2, Colors.hp100.g, Colors.hp100.b, Colors.hp100.a)
	-- >0.5 < 0.8
	elseif (party4HPDeficit > 0.5) and (party4HPDeficit < 0.8) then
		HP_PARTY4_BAR_TEXTURE:SetVertexColor(Colors.hp50.r, (1-party4HPDeficit)*2, Colors.hp50.b, Colors.hp50.a)
		HP_PARTY4_BG_TEXTURE1:SetVertexColor(Colors.hp50.r, (1-party4HPDeficit)*2, Colors.hp50.b, Colors.hp50.a)
		HP_PARTY4_DEFICIT:SetTextColor(Colors.hp50.r, (1-party4HPDeficit)*2, Colors.hp50.b, Colors.hp50.a)
	-- 20-
	elseif (party4HPDeficit == 0.8) or (party4HPDeficit > 0.8) then 
		HP_PARTY4_BAR_TEXTURE:SetVertexColor(Colors.hp20.r, Colors.hp20.g, Colors.hp20.b, Colors.hp20.a)
		HP_PARTY4_BG_TEXTURE1:SetVertexColor(Colors.hp20.r, Colors.hp20.g, Colors.hp20.b, Colors.hp20.a)
		HP_PARTY4_DEFICIT:SetTextColor(Colors.hp20.r, Colors.hp20.g, Colors.hp20.b, Colors.hp20.a)
		--startflashing
		--UIFrameFlash(HP_PARTY4_BAR_TEXTURE, 1, 1, 1, true, 0, 0)
		--UIFrameFlash(HP_PARTY4_BG_TEXTURE1, 1, 1, 1, true, 0, 0)
	end
	end
end
---------------------------------------------------------
function MP_Party4_Color()
	local party4MPDeficit =  (1-(UnitMana("party4")/UnitManaMax("party4")))
	--powertype mana
	if (UnitPowerType("party4")==0) then 
		--100
		if (party4MPDeficit == 0) then 
			MP_PARTY4_BAR_TEXTURE:SetVertexColor(Colors.mp100.r, Colors.mp100.g, Colors.mp100.b, Colors.mp100.a)
			MP_PARTY4_BG_TEXTURE1:SetVertexColor(Colors.mp100.r, Colors.mp100.g, Colors.mp100.b, Colors.mp100.a)
			MP_PARTY4_DEFICIT:SetTextColor(Colors.mp100.r, Colors.mp100.g, Colors.mp100.b, Colors.mp100.a)
		--  > 0 < 0.5
		elseif (party4MPDeficit > 0) and (party4MPDeficit < 0.5) then 
			MP_PARTY4_BAR_TEXTURE:SetVertexColor(party4MPDeficit*2, party4MPDeficit*2, Colors.mp100.b, Colors.mp100.a)
			MP_PARTY4_BG_TEXTURE1:SetVertexColor(party4MPDeficit*2, party4MPDeficit*2, Colors.mp100.b, Colors.mp100.a)
			MP_PARTY4_DEFICIT:SetTextColor(party4MPDeficit*2, party4MPDeficit*2, Colors.mp100.b, Colors.mp100.a)
		-- >0.5 < 0.8
		elseif (party4MPDeficit > 0.5) and (party4MPDeficit < 0.8) then
			MP_PARTY4_BAR_TEXTURE:SetVertexColor(Colors.mp50.r, (1-party4MPDeficit)*2, (1-party4MPDeficit)*2, Colors.mp50.a)
			MP_PARTY4_BG_TEXTURE1:SetVertexColor(Colors.mp50.r, (1-party4MPDeficit)*2, (1-party4MPDeficit)*2, Colors.mp50.a)
			MP_PARTY4_DEFICIT:SetTextColor(Colors.mp50.r, (1-party4MPDeficit)*2, (1-party4MPDeficit)*2, Colors.mp50.a)
		-- 20-
		elseif (party4MPDeficit == 0.8) or (party4MPDeficit > 0.8) then
			MP_PARTY4_BAR_TEXTURE:SetVertexColor(Colors.mp20.r, Colors.mp20.g, Colors.mp20.b, Colors.mp20.a)
			MP_PARTY4_BG_TEXTURE1:SetVertexColor(Colors.mp20.r, Colors.mp20.g, Colors.mp20.b, Colors.mp20.a)
			MP_PARTY4_DEFICIT:SetTextColor(Colors.mp20.r, Colors.mp20.g, Colors.mp20.b, Colors.mp20.a)
		--startflashing
			--UIFrameFlash(MP_PARTY4_BAR_TEXTURE, 1, 1, 1, true, 0, 0)
			--UIFrameFlash(MP_PARTY4_BG_TEXTURE1, 1, 1, 1, true, 0, 0)	
		end
	--powertype rage
	elseif (UnitPowerType("party4")==1) then 
		MP_PARTY4_BAR_TEXTURE:SetVertexColor(1, 0, 0, Colors.mp100.a)
		MP_PARTY4_BG_TEXTURE1:SetVertexColor(1, 0, 0, Colors.mp100.a)
		MP_PARTY4_DEFICIT:SetTextColor(1, 0, 0, Colors.mp100.a)
	--powertype focus/energy
	elseif (UnitPowerType("party4")==2) or (UnitPowerType("party4")==3) then 
		MP_PARTY4_BAR_TEXTURE:SetVertexColor(1, 1, 0, Colors.mp100.a)
		MP_PARTY4_BG_TEXTURE1:SetVertexColor(1, 1, 0,Colors.mp100.a)
		MP_PARTY4_DEFICIT:SetTextColor(1, 1, 0, Colors.mp100.a)
	end
end
---------------------------------------------------------
function HP_Pet_Color()
	local petHPDeficit =  (1-(UnitHealth("pet")/UnitHealthMax("pet")))
	-- grey frame for those conditions
	if (UnitIsGhost("pet")) 
	or (UnitIsDead("pet")) then
		HP_PET_BAR_TEXTURE:SetVertexColor(0.5, 0.5, 0.5, Colors.hp100.a)
		HP_PET_BG_TEXTURE1:SetVertexColor(0.5, 0.5, 0.5, Colors.hp100.a)
		HP_PET_CURRENT:SetTextColor(0.5, 0.5, 0.5, Colors.hp100.a)
		HP_PET_PERCENT:SetTextColor(0.5, 0.5, 0.5, Colors.hp100.a)
		HP_PET_DEFICIT:SetTextColor(0.5, 0.5, 0.5, Colors.hp100.a)
	else
	--100
	if (petHPDeficit == 0) then 
		HP_PET_BAR_TEXTURE:SetVertexColor(Colors.hp100.r, Colors.hp100.g, Colors.hp100.b, Colors.hp100.a)
		HP_PET_BG_TEXTURE1:SetVertexColor(Colors.hp100.r, Colors.hp100.g, Colors.hp100.b, Colors.hp100.a)
		HP_PET_CURRENT:SetTextColor(Colors.hp100.r, Colors.hp100.g, Colors.hp100.b, Colors.hp100.a)
		HP_PET_PERCENT:SetTextColor(Colors.hp100.r, Colors.hp100.g, Colors.hp100.b, Colors.hp100.a)
		HP_PET_DEFICIT:SetTextColor(Colors.hp100.r, Colors.hp100.g, Colors.hp100.b, Colors.hp100.a)
	--  > 0 < 0.5
	elseif (petHPDeficit > 0) and (petHPDeficit < 0.5) then 
		HP_PET_BAR_TEXTURE:SetVertexColor(petHPDeficit*2, Colors.hp100.g, Colors.hp100.b, Colors.hp100.a)
		HP_PET_BG_TEXTURE1:SetVertexColor(petHPDeficit*2, Colors.hp100.g, Colors.hp100.b, Colors.hp100.a)
		HP_PET_CURRENT:SetTextColor(petHPDeficit*2, Colors.hp100.g, Colors.hp100.b, Colors.hp100.a)
		HP_PET_PERCENT:SetTextColor(petHPDeficit*2, Colors.hp100.g, Colors.hp100.b, Colors.hp100.a)
		HP_PET_DEFICIT:SetTextColor(petHPDeficit*2, Colors.hp100.g, Colors.hp100.b, Colors.hp100.a)
	-- >0.5 < 0.8
	elseif (petHPDeficit > 0.5) and (petHPDeficit < 0.8) then
		HP_PET_BAR_TEXTURE:SetVertexColor(Colors.hp50.r, (1-petHPDeficit)*2, Colors.hp50.b, Colors.hp50.a)
		HP_PET_BG_TEXTURE1:SetVertexColor(Colors.hp50.r, (1-petHPDeficit)*2, Colors.hp50.b, Colors.hp50.a)
		HP_PET_CURRENT:SetTextColor(Colors.hp50.r, (1-petHPDeficit)*2, Colors.hp50.b, Colors.hp50.a)
		HP_PET_PERCENT:SetTextColor(Colors.hp50.r, (1-petHPDeficit)*2, Colors.hp50.b, Colors.hp50.a)
		HP_PET_DEFICIT:SetTextColor(Colors.hp50.r, (1-petHPDeficit)*2, Colors.hp50.b, Colors.hp50.a)
	-- 20-
	elseif (petHPDeficit == 0.8) or (petHPDeficit > 0.8) then 
		HP_PET_BAR_TEXTURE:SetVertexColor(Colors.hp20.r, Colors.hp20.g, Colors.hp20.b, Colors.hp20.a)
		HP_PET_BG_TEXTURE1:SetVertexColor(Colors.hp20.r, Colors.hp20.g, Colors.hp20.b, Colors.hp20.a)
		HP_PET_CURRENT:SetTextColor(Colors.hp20.r, Colors.hp20.g, Colors.hp20.b, Colors.hp20.a)
		HP_PET_PERCENT:SetTextColor(Colors.hp20.r, Colors.hp20.g, Colors.hp20.b, Colors.hp20.a)
		HP_PET_DEFICIT:SetTextColor(Colors.hp20.r, Colors.hp20.g, Colors.hp20.b, Colors.hp20.a)
		--startflashing
		--UIFrameFlash(HP_PET_BAR_TEXTURE, 1, 1, 1, true, 0, 0)
		--UIFrameFlash(HP_PET_BG_TEXTURE1, 1, 1, 1, true, 0, 0)
	end
	end
end
---------------------------------------------------------
function MP_Pet_Color()
	local petMPDeficit =  (1-(UnitMana("pet")/UnitManaMax("pet")))
	--powertype mana
	if (UnitPowerType("pet")==0) then 
		--100
		if (petMPDeficit == 0) then 
			MP_PET_BAR_TEXTURE:SetVertexColor(Colors.mp100.r, Colors.mp100.g, Colors.mp100.b, Colors.mp100.a)
			MP_PET_BG_TEXTURE1:SetVertexColor(Colors.mp100.r, Colors.mp100.g, Colors.mp100.b, Colors.mp100.a)
			MP_PET_CURRENT:SetTextColor(Colors.mp100.r, Colors.mp100.g, Colors.mp100.b, Colors.mp100.a)
			MP_PET_PERCENT:SetTextColor(Colors.mp100.r, Colors.mp100.g, Colors.mp100.b, Colors.mp100.a)
			MP_PET_DEFICIT:SetTextColor(Colors.mp100.r, Colors.mp100.g, Colors.mp100.b, Colors.mp100.a)
		--  > 0 < 0.5
		elseif (petMPDeficit > 0) and (petMPDeficit < 0.5) then 
			MP_PET_BAR_TEXTURE:SetVertexColor(petMPDeficit*2, petMPDeficit*2, Colors.mp100.b, Colors.mp100.a)
			MP_PET_BG_TEXTURE1:SetVertexColor(petMPDeficit*2, petMPDeficit*2, Colors.mp100.b, Colors.mp100.a)
			MP_PET_CURRENT:SetTextColor(petMPDeficit*2, petMPDeficit*2, Colors.mp100.b, Colors.mp100.a)
			MP_PET_PERCENT:SetTextColor(petMPDeficit*2, petMPDeficit*2, Colors.mp100.b, Colors.mp100.a)
			MP_PET_DEFICIT:SetTextColor(petMPDeficit*2, petMPDeficit*2, Colors.mp100.b, Colors.mp100.a)
		-- >0.5 < 0.8
		elseif (petMPDeficit > 0.5) and (petMPDeficit < 0.8) then
			MP_PET_BAR_TEXTURE:SetVertexColor(Colors.mp50.r, (1-petMPDeficit)*2, (1-petMPDeficit)*2, Colors.mp50.a)
			MP_PET_BG_TEXTURE1:SetVertexColor(Colors.mp50.r, (1-petMPDeficit)*2, (1-petMPDeficit)*2, Colors.mp50.a)
			MP_PET_CURRENT:SetTextColor(Colors.mp50.r, (1-petMPDeficit)*2, (1-petMPDeficit)*2, Colors.mp50.a)
			MP_PET_PERCENT:SetTextColor(Colors.mp50.r, (1-petMPDeficit)*2, (1-petMPDeficit)*2, Colors.mp50.a)
			MP_PET_DEFICIT:SetTextColor(Colors.mp50.r, (1-petMPDeficit)*2, (1-petMPDeficit)*2, Colors.mp50.a)
		-- 20-
		elseif (petMPDeficit == 0.8) or (petMPDeficit > 0.8) then
			MP_PET_BAR_TEXTURE:SetVertexColor(Colors.mp20.r, Colors.mp20.g, Colors.mp20.b, Colors.mp20.a)
			MP_PET_BG_TEXTURE1:SetVertexColor(Colors.mp20.r, Colors.mp20.g, Colors.mp20.b, Colors.mp20.a)
			MP_PET_CURRENT:SetTextColor(Colors.mp20.r, Colors.mp20.g, Colors.mp20.b, Colors.mp20.a)
			MP_PET_PERCENT:SetTextColor(Colors.mp20.r, Colors.mp20.g, Colors.mp20.b, Colors.mp20.a)
			MP_PET_DEFICIT:SetTextColor(Colors.mp20.r, Colors.mp20.g, Colors.mp20.b, Colors.mp20.a)
		--startflashing
			--UIFrameFlash(MP_PET_BAR_TEXTURE, 1, 1, 1, true, 0, 0)
			--UIFrameFlash(MP_PET_BG_TEXTURE1, 1, 1, 1, true, 0, 0)	
		end
	--powertype rage
	elseif (UnitPowerType("pet")==1) then 
		MP_PET_BAR_TEXTURE:SetVertexColor(1, 0, 0, Colors.mp100.a)
		MP_PET_BG_TEXTURE1:SetVertexColor(1, 0, 0, Colors.mp100.a)
		MP_PET_CURRENT:SetTextColor(1, 0, 0, Colors.mp100.a)
		MP_PET_PERCENT:SetTextColor(1, 0, 0, Colors.mp100.a)
		MP_PET_DEFICIT:SetTextColor(1, 0, 0, Colors.mp100.a)
	--powertype focus/energy
	elseif (UnitPowerType("pet")==2) or (UnitPowerType("pet")==3) then 
		MP_PET_BAR_TEXTURE:SetVertexColor(1, 1, 0, Colors.mp100.a)
		MP_PET_BG_TEXTURE1:SetVertexColor(1, 1, 0,Colors.mp100.a)
		MP_PET_CURRENT:SetTextColor(1, 1, 0, Colors.mp100.a)
		MP_PET_PERCENT:SetTextColor(1, 1, 0, Colors.mp100.a)
		MP_PET_DEFICIT:SetTextColor(1, 1, 0, Colors.mp100.a)
	end
end
---------------------------------------------------------
function HP_TargetTarget_Color()
	local targettargetHPDeficit =  (1-(UnitHealth("targettarget")/UnitHealthMax("targettarget")))
	if (UnitIsTapped("targettarget")) and (not UnitIsTappedByPlayer("targettarget"))
	or (UnitIsTrivial("targettarget"))
	or (UnitIsGhost("targettarget")) 
	or (UnitIsDead("targettarget"))
	or (not UnitIsConnected("targettarget")) then
	
		HP_TARGETTARGET_BAR_TEXTURE:SetVertexColor(0.5, 0.5, 0.5, Colors.hp100.a)
		HP_TARGETTARGET_BG_TEXTURE1:SetVertexColor(0.5, 0.5, 0.5, Colors.hp100.a)
		HP_TARGETTARGET_CURRENT:SetTextColor(0.5, 0.5, 0.5, Colors.hp100.a)
		HP_TARGETTARGET_PERCENT:SetTextColor(0.5, 0.5, 0.5, Colors.hp100.a)
		HP_TARGETTARGET_DEFICIT:SetTextColor(0.5, 0.5, 0.5, Colors.hp100.a)
	else
	--100
	if (targettargetHPDeficit == 0) then 
		HP_TARGETTARGET_BAR_TEXTURE:SetVertexColor(Colors.hp100.r, Colors.hp100.g, Colors.hp100.b, Colors.hp100.a)
		HP_TARGETTARGET_BG_TEXTURE1:SetVertexColor(Colors.hp100.r, Colors.hp100.g, Colors.hp100.b, Colors.hp100.a)
		HP_TARGETTARGET_CURRENT:SetTextColor(Colors.hp100.r, Colors.hp100.g, Colors.hp100.b, Colors.hp100.a)
		HP_TARGETTARGET_PERCENT:SetTextColor(Colors.hp100.r, Colors.hp100.g, Colors.hp100.b, Colors.hp100.a)
		HP_TARGETTARGET_DEFICIT:SetTextColor(Colors.hp100.r, Colors.hp100.g, Colors.hp100.b, Colors.hp100.a)
	--  > 0 < 0.5
	elseif (targettargetHPDeficit > 0) and (targettargetHPDeficit < 0.5) then 
		HP_TARGETTARGET_BAR_TEXTURE:SetVertexColor(targettargetHPDeficit*2, Colors.hp100.g, Colors.hp100.b, Colors.hp100.a)
		HP_TARGETTARGET_BG_TEXTURE1:SetVertexColor(targettargetHPDeficit*2, Colors.hp100.g, Colors.hp100.b, Colors.hp100.a)
		HP_TARGETTARGET_CURRENT:SetTextColor(targettargetHPDeficit*2, Colors.hp100.g, Colors.hp100.b, Colors.hp100.a)
		HP_TARGETTARGET_PERCENT:SetTextColor(targettargetHPDeficit*2, Colors.hp100.g, Colors.hp100.b, Colors.hp100.a)
		HP_TARGETTARGET_DEFICIT:SetTextColor(targettargetHPDeficit*2, Colors.hp100.g, Colors.hp100.b, Colors.hp100.a)
	-- >0.5 < 0.8
	elseif (targettargetHPDeficit > 0.5) and (targettargetHPDeficit < 0.8) then
		HP_TARGETTARGET_BAR_TEXTURE:SetVertexColor(Colors.hp50.r, (1-targettargetHPDeficit)*2, Colors.hp50.b, Colors.hp50.a)
		HP_TARGETTARGET_BG_TEXTURE1:SetVertexColor(Colors.hp50.r, (1-targettargetHPDeficit)*2, Colors.hp50.b, Colors.hp50.a)
		HP_TARGETTARGET_CURRENT:SetTextColor(Colors.hp50.r, (1-targettargetHPDeficit)*2, Colors.hp50.b, Colors.hp50.a)
		HP_TARGETTARGET_PERCENT:SetTextColor(Colors.hp50.r, (1-targettargetHPDeficit)*2, Colors.hp50.b, Colors.hp50.a)
		HP_TARGETTARGET_DEFICIT:SetTextColor(Colors.hp50.r, (1-targettargetHPDeficit)*2, Colors.hp50.b, Colors.hp50.a)
	-- 20-
	elseif (targettargetHPDeficit == 0.8) or (targettargetHPDeficit > 0.8) then 
		HP_TARGETTARGET_BAR_TEXTURE:SetVertexColor(Colors.hp20.r, Colors.hp20.g, Colors.hp20.b, Colors.hp20.a)
		HP_TARGETTARGET_BG_TEXTURE1:SetVertexColor(Colors.hp20.r, Colors.hp20.g, Colors.hp20.b, Colors.hp20.a)
		HP_TARGETTARGET_CURRENT:SetTextColor(Colors.hp20.r, Colors.hp20.g, Colors.hp20.b, Colors.hp20.a)
		HP_TARGETTARGET_PERCENT:SetTextColor(Colors.hp20.r, Colors.hp20.g, Colors.hp20.b, Colors.hp20.a)
		HP_TARGETTARGET_DEFICIT:SetTextColor(Colors.hp20.r, Colors.hp20.g, Colors.hp20.b, Colors.hp20.a)
		--startflashing
		--UIFrameFlash(HP_TARGETTARGET_BAR_TEXTURE, 1, 1, 1, true, 0, 0)
		--UIFrameFlash(HP_TARGETTARGET_BG_TEXTURE1, 1, 1, 1, true, 0, 0)
	end
	end
end
---------------------------------------------------------
function MP_TargetTarget_Color()
	local targettargetMPDeficit =  (1-(UnitMana("targettarget")/UnitManaMax("targettarget")))
	--powertype mana
	if (UnitPowerType("targettarget")==0) then 
		--100
		if (targettargetMPDeficit == 0) then 
			MP_TARGETTARGET_BAR_TEXTURE:SetVertexColor(Colors.mp100.r, Colors.mp100.g, Colors.mp100.b, Colors.mp100.a)
			MP_TARGETTARGET_BG_TEXTURE1:SetVertexColor(Colors.mp100.r, Colors.mp100.g, Colors.mp100.b, Colors.mp100.a)
			MP_TARGETTARGET_CURRENT:SetTextColor(Colors.mp100.r, Colors.mp100.g, Colors.mp100.b, Colors.mp100.a)
			MP_TARGETTARGET_PERCENT:SetTextColor(Colors.mp100.r, Colors.mp100.g, Colors.mp100.b, Colors.mp100.a)
			MP_TARGETTARGET_DEFICIT:SetTextColor(Colors.mp100.r, Colors.mp100.g, Colors.mp100.b, Colors.mp100.a)
		--  > 0 < 0.5
		elseif (targettargetMPDeficit > 0) and (targettargetMPDeficit < 0.5) then 
			MP_TARGETTARGET_BAR_TEXTURE:SetVertexColor(targettargetMPDeficit*2, targettargetMPDeficit*2, Colors.mp100.b, Colors.mp100.a)
			MP_TARGETTARGET_BG_TEXTURE1:SetVertexColor(targettargetMPDeficit*2, targettargetMPDeficit*2, Colors.mp100.b, Colors.mp100.a)
			MP_TARGETTARGET_CURRENT:SetTextColor(targettargetMPDeficit*2, targettargetMPDeficit*2, Colors.mp100.b, Colors.mp100.a)
			MP_TARGETTARGET_PERCENT:SetTextColor(targettargetMPDeficit*2, targettargetMPDeficit*2, Colors.mp100.b, Colors.mp100.a)
			MP_TARGETTARGET_DEFICIT:SetTextColor(targettargetMPDeficit*2, targettargetMPDeficit*2, Colors.mp100.b, Colors.mp100.a)
		-- >0.5 < 0.8
		elseif (targettargetMPDeficit > 0.5) and (targettargetMPDeficit < 0.8) then
			MP_TARGETTARGET_BAR_TEXTURE:SetVertexColor(Colors.mp50.r, (1-targettargetMPDeficit)*2, (1-targettargetMPDeficit)*2, Colors.mp50.a)
			MP_TARGETTARGET_BG_TEXTURE1:SetVertexColor(Colors.mp50.r, (1-targettargetMPDeficit)*2, (1-targettargetMPDeficit)*2, Colors.mp50.a)
			MP_TARGETTARGET_CURRENT:SetTextColor(Colors.mp50.r, (1-targettargetMPDeficit)*2, (1-targettargetMPDeficit)*2, Colors.mp50.a)
			MP_TARGETTARGET_PERCENT:SetTextColor(Colors.mp50.r, (1-targettargetMPDeficit)*2, (1-targettargetMPDeficit)*2, Colors.mp50.a)
			MP_TARGETTARGET_DEFICIT:SetTextColor(Colors.mp50.r, (1-targettargetMPDeficit)*2, (1-targettargetMPDeficit)*2, Colors.mp50.a)
		-- 20-
		elseif (targettargetMPDeficit == 0.8) or (targettargetMPDeficit > 0.8) then
			MP_TARGETTARGET_BAR_TEXTURE:SetVertexColor(Colors.mp20.r, Colors.mp20.g, Colors.mp20.b, Colors.mp20.a)
			MP_TARGETTARGET_BG_TEXTURE1:SetVertexColor(Colors.mp20.r, Colors.mp20.g, Colors.mp20.b, Colors.mp20.a)
			MP_TARGETTARGET_CURRENT:SetTextColor(Colors.mp20.r, Colors.mp20.g, Colors.mp20.b, Colors.mp20.a)
			MP_TARGETTARGET_PERCENT:SetTextColor(Colors.mp20.r, Colors.mp20.g, Colors.mp20.b, Colors.mp20.a)
			MP_TARGETTARGET_DEFICIT:SetTextColor(Colors.mp20.r, Colors.mp20.g, Colors.mp20.b, Colors.mp20.a)
		--startflashing
			--UIFrameFlash(MP_TARGETTARGET_BAR_TEXTURE, 1, 1, 1, true, 0, 0)
			--UIFrameFlash(MP_TARGETTARGET_BG_TEXTURE1, 1, 1, 1, true, 0, 0)	
		end
	--powertype rage
	elseif (UnitPowerType("targettarget")==1) then 
		MP_TARGETTARGET_BAR_TEXTURE:SetVertexColor(1, 0, 0, Colors.mp100.a)
		MP_TARGETTARGET_BG_TEXTURE1:SetVertexColor(1, 0, 0, Colors.mp100.a)
		MP_TARGETTARGET_CURRENT:SetTextColor(1, 0, 0, Colors.mp100.a)
		MP_TARGETTARGET_PERCENT:SetTextColor(1, 0, 0, Colors.mp100.a)
		MP_TARGETTARGET_DEFICIT:SetTextColor(1, 0, 0, Colors.mp100.a)
	--powertype focus/energy
	elseif (UnitPowerType("targettarget")==2) or (UnitPowerType("targettarget")==3) then 
		MP_TARGETTARGET_BAR_TEXTURE:SetVertexColor(1, 1, 0, Colors.mp100.a)
		MP_TARGETTARGET_BG_TEXTURE1:SetVertexColor(1, 1, 0,Colors.mp100.a)
		MP_TARGETTARGET_CURRENT:SetTextColor(1, 1, 0, Colors.mp100.a)
		MP_TARGETTARGET_PERCENT:SetTextColor(1, 1, 0, Colors.mp100.a)
		MP_TARGETTARGET_DEFICIT:SetTextColor(1, 1, 0, Colors.mp100.a)
	end
end